%% from /home/sergio/KCARTA/NONLTE/VT_48PROFILES_120_385ppmv_v121_H16_NLTEH16_Jan2020/

addpath /home/sergio/KCARTA/MATLAB
addpath /home/sergio/KCARTA/MATLAB/NLTE/

figure(1)
% see +1252 n_gas_wt_spectra.f90
% simple routine to get US STD 2350 NLTE temps
%    SUBROUTINE GetUSSTD_2350(raPavg,iStart,daJL,daJU,iaJ_UorL,raLTE_STD,raNLTE_STD)
%
fname = ['/asl/data/kcarta_sergio/KCDATA/NLTE/LA/xnlte_1_1_1_6_sol_0.genln2'];

%% see nlte_120km.nml
%%  caaNLTETemp(1)     = 'sergio_merge/vtPROF_sSOL.prf'
fname = ['/home/sergio/KCARTA/NONLTE/VT_48PROFILES_120_385ppmv_v121_H16_NLTEH16_Jan2020/sergio_merge/vt1_s0.prf'];
figure(1); 
[p,T,QV,Tnlte,bandcenter] = read_vt_profiles(fname);
set(gca,'ydir','reverse');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% these are cut from /asl/s1/sergio/JUNK/NLTErunsLOGS/nlte_1_1_0_0.log
%% which gives the LTE klayers profile and the nlte profile file (fname above)

[head,ha,prof,pa] = rtpread('/home/sergio/KCARTA/NONLTE/VT_48PROFILES_120_385ppmv_v121_H16_NLTEH16_Jan2020/RTP_100/rtp_regress_0_385.op.rtp');

%T1 = load('/home/sergio/KCARTA/NONLTE/VT_48PROFILES_120_385ppmv_v121_H16_NLTEH16_Jan2020/nlte_1_1_0_0_log_T1.txt');  %% shows US std ugh
%T2 = load('/home/sergio/KCARTA/NONLTE/VT_48PROFILES_120_385ppmv_v121_H16_NLTEH16_Jan2020/nlte_1_1_0_0_log_T2.txt');  %% shows US std ugh
T2 = load('/home/sergio/KCARTA/NONLTE/VT_48PROFILES_120_385ppmv_v121_H16_NLTEH16_Jan2020/nlte_1_1_0_0_log_T2b.txt'); %% shows current profile
T2upper = load('/home/sergio/KCARTA/NONLTE/VT_48PROFILES_120_385ppmv_v121_H16_NLTEH16_Jan2020/nlte_1_1_0_0_log_T2upper.txt');  %% show current profile but UA

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nl = 101;
nl = 120;
profN = prof.plevs(1:nl-1,:)-prof.plevs(2:nl,:);
profD = log(prof.plevs(1:nl-1,:)./prof.plevs(2:nl,:));
prof.plays = zeros(size(prof.plevs)); prof.plays(1:nl-1,:) = profN./profD;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hold on
semilogy(T,p,'c.-',prof.ptemp(:,1),prof.plays(:,1),'gx-',T2(:,3),T2(:,2),'kx-',T2upper(:,4),T2upper(:,2),'ks-',T2(:,6),T2(:,2),'mx-')
set(gca,'ydir','reverse');
hold off
hl = legend('VT prof, Tk','VT prof, Tnlte','redo VT prof, Tk','klayers ptemp(z)','location','best');
set(hl,'fontsize',8)
grid on

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lblrtm = load('TAPE6_compare');
tape4 = read_tape4('TAPE4_p01_s000',lblrtm(:,2),lblrtm(:,3));

hold on
semilogy(lblrtm(:,4),lblrtm(:,3),'r--','linewidth',4)
hold off

figure(2)
semilogy(Tnlte,p,'b',Tnlte(:,14),p,'r'); set(gca,'ydir','reverse'); title('KCARTA'); grid on

figure(3)
plot(tape4.raaT,tape4.raH,'b',tape4.raaT(:,1),tape4.raH,'kx-',tape4.raaT(:,14),tape4.raH,'rx-')
semilogy(tape4.raaT_P,tape4.ra_P,'b',tape4.raaT_P(:,1),tape4.ra_P,'kx-',tape4.raaT_P(:,15),tape4.ra_P,'rx-')
set(gca,'ydir','reverse'); grid on
title('LBLRTM');

figure(4)
nn = length(tape4.raVib);
for ii = 2 : nn
  boo = abs(tape4.raVib(ii)-bandcenter);
  boo = find(boo == min(boo),1);
  semilogy(tape4.raaT_P(:,ii),tape4.ra_P,'bx-',Tnlte(:,boo),p,'ro-',...
           tape4.raaT_P(:,1),tape4.ra_P,'c.-',T,p,'m.-'); 
  set(gca,'ydir','reverse'); grid on
  title(['LBLRTM ' num2str(tape4.raVib(ii)) ' KCARTA ' num2str(bandcenter(boo))])
  delta = tape4.raVib(ii) - bandcenter(boo);
  fprintf(1,'ii = %3i LBLRTM centerfreq %10.6f jj=%3i kCARTA centerfreq %10.6f delta = %8.6f\n',ii,tape4.raVib(ii),boo,bandcenter(boo),delta)
  pause;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%{  
 Printing UA FILE summary stats at open : 
 /scratch/2505836/Results_0/vt1_sun0_120km.dat_UA                               
  
 Regular freqs etc .... 
   rFrLow,rFrHigh =    2105.000       2504.998    
   iFileIDLo,iFileIDHi =          282         297
   df, chunksize =   2.4999999E-03   25.00000    
   iTag,iTotalStuff =            8           2
        2205        2480          11
   2205.000       2480.000    
 Opened following file for UA general output :
 /scratch/2505836/Results_0/vt1_sun0_120km.dat_UA                               
  
 Upper atmosphere pressure levels
   iL       P(iL)         P(iL+1)           Pav
 -----------------------------------------------
           1  4.9999999E-03  4.8520002E-03  4.9256347E-03
           2  4.8520002E-03  4.5630001E-03  4.7060219E-03
           3  4.5630001E-03  4.1830000E-03  4.3702470E-03
           4  4.1830000E-03  3.6549999E-03  3.9130631E-03
           5  3.6549999E-03  2.3790000E-03  2.9714785E-03
           6  2.3790000E-03  1.5560000E-03  1.9384692E-03
           7  1.5560000E-03  1.0240000E-03  1.2715047E-03
           8  1.0240000E-03  6.7909999E-04  8.3977875E-04
           9  6.7909999E-04  4.5510000E-04  5.5964844E-04
          10  4.5510000E-04  3.0889999E-04  3.7729074E-04
          11  3.0889999E-04  2.1319999E-04  2.5809972E-04
          12  2.1319999E-04  1.5040000E-04  1.7997762E-04
          13  1.5040000E-04  1.0910000E-04  1.2864701E-04
          14  1.0910000E-04  8.1799997E-05  9.4795716E-05
          15  8.1799997E-05  6.3519998E-05  7.2275121E-05
          16  6.3519998E-05  5.0999999E-05  5.7031135E-05
 -----------------------------------------------
%}
