function [tape4] = read_tape4(fname,raZ,raP)

%% see https://www.atmos.umd.edu/~ytma/lblrtm/lblrtm_instructions.html TAPE4 records

ee = exist(fname);
if ee == 0
  fname
  error('file not found')
end

fid = fopen(fname,'r');

%% read header comments
GoOn = 1;
iCnt = 0;
while GoOn > 0
  strAll = fgetl(fid);
  str1   = strAll(1);
  if strcmp(str1,'!')
    GoOn = 1;
    iCnt = iCnt + 1;
  else
    GoOn = -1;
  end
end

iNumLevs = abs(str2num(strAll(7:10)));

strAll = fgetl(fid);  %% get ----

%% now read the VIB ids
GoOn = 1;
iCnt = 0;
while GoOn > 0
  strAll = fgetl(fid);
  str1   = strAll(1);
  if strcmp(str1,'-')
    GoOn = -1;
  else    
    GoOn = +1;
    iCnt = iCnt + 1;
    %tape4.iaMolID(iCnt) = str2num(strAll(1:10));
    tape4.iaISO(iCnt)   = str2num(strAll(11:11));
    tape4.caID{iCnt}    = strAll(12:20);
    tape4.raVib(iCnt)   = str2num(strAll(21:30));
  end
end
fprintf(1,'expecting %3i T(z) profiles over %3i levels \n',iCnt,iNumLevs);

for ii = 1 : iNumLevs
  [raH(ii),raaT(ii,:)] = get_blocks(fid,iCnt);
end

whos raH raaT

fclose(fid);

tape4.raH = raH;
tape4.raaT = raaT;

if nargin > 1
  %% aha you have sent in (Z,P)
  [mm,nn] = size(raaT);
  tape4.ra_P  = raP;
  tape4.raZ_P = raZ;
  for ii = 1 : nn
    tape4.raaT_P(:,ii) = interp1(raH,raaT(:,ii),raZ,[],'extrap');
  end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [rH,raT] = get_blocks(fid,iCnt);

for ix = 1 : 1
  strAll = fgetl(fid);
  xarr = strread(strAll); 
  mm = length(xarr);
  %fprintf(1,'%3i : %s : %3i \n',ix,strAll,mm);
  rH = xarr(1);
  xarr = xarr(2:mm);
  iaInd = 1:length(xarr);
  raT(iaInd) = xarr';
end

while length(raT) < iCnt
  strAll = fgetl(fid);
  xarr = strread(strAll); 
  mm = length(xarr);
  %fprintf(1,'%3i : %s : %3i \n',ix,strAll,mm);
  iaInd = [1:length(xarr)] + length(raT);
  raT(iaInd) = xarr';
end

%rH
%raT
