function [usual,lte,nlte,inprogress,rad] = check_progress(iProf,iLoad);

%% see cluster_run_nlte_lte_001_100.m
%% output = usual,lte,nlte : 3 matrces, 13x6  (13 solang x 6 scannang)
%%          inprogress     : a single number saying how many files from iProf have been found in JUNK_PROCESS
%%          rad            : if iLoad > 0, a structure containing radiances for the complete (uusual,lte,nlte) calcs

%% Example 1 : see  driver_check_progress.m, which loops over [usual,lte,nlte,inprogress] = check_progress(iProf);
%% Example 2 : [usual,lte,nlte,inprogress,rad] = check_progress(1,1);
%{
[usual,lte,nlte,inprogress,rad] = check_progress(1,1);
ix = find(rad.w >= 2350,1);    %% in between lines, small diffs (1 K)
ix = find(rad.w >= 2349.92,1); %% on a line, huge diffs (60 K)
tusual = rad2bt(2350,rad.usual(:,:,ix));
tlte   = rad2bt(2350,rad.lte(:,:,ix));
tnlte  = rad2bt(2350,rad.nlte(:,:,ix));

thesolang = [00 15 30 40 50 60 70 80 85 90 95 100 120];
thescanang = [00 10 20 30 40 50];

imagesc(thescanang,thesolang,tusual); colorbar; caxis([230 250])
imagesc(thescanang,thesolang,tlte-tusual); colorbar; caxis([-1 +1]*0.5); colormap(usa2);
imagesc(thescanang,thesolang,tnlte-tusual); colorbar; colormap(jet)

r0usual = squeeze(rad.usual(1,1,:));
r0lte   = squeeze(rad.lte(1,1,:));
r0nlte  = squeeze(rad.nlte(1,1,:));
[fc,qc] = quickconvolve(rad.w,[r0usual r0lte r0nlte],1,1);
tc = rad2bt(fc,qc);
plot(fc,tc);
plot(fc,tc(:,2)-tc(:,1),fc,tc(:,3)-tc(:,1));
%}

addpath /home/sergio/KCARTA/MATLAB

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nargin == 1
  iLoad = -1;
end

thesolang = [00 15 30 40 50 60 70 80 85 90 95 100 120];
thescanang = [00 10 20 30 40 50];

foutdir0 = ['Results/JUNK_PROCESS/'];
for ii = 1 : length(thesolang)
  for jj = 1 : length(thescanang)
    solang = thesolang(ii);
    scanang = thescanang(jj);
    foutdir = ['Results/Results_lte_Usual/'];
      usuallte_out = [foutdir 'usuallterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
    foutdir = ['Results/Results_lte_Rhead/'];
      lte_out      = [foutdir 'lterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
    foutdir = ['Results/Results_' num2str(scanang) '/'];
      nlte_out     = [foutdir 'nlterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
   usual(ii,jj) = length(dir(usuallte_out));
   lte(ii,jj)   = length(dir(lte_out));
   nlte(ii,jj)  = length(dir(nlte_out));

   if iLoad > 0 & usual(ii,jj) == 1 & lte(ii,jj) == 1 & nlte(ii,jj) == 1
     [dusual,w] = readkcstd(usuallte_out);
     %[dlte,w] = readkcstd([lte_out '_UA']);
     %[dnlte,w] = readkcstd([nlte_out '_UA']);
     [dlte,w] = readkcstd([lte_out]);
     [dnlte,w] = readkcstd([nlte_out]);
     rad.usual(ii,jj,:) = dusual;
     rad.lte(ii,jj,:)   = dlte;
     rad.nlte(ii,jj,:)  = dnlte;
     rad.w = w;
   end
 end
end

%{
[sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ ls -ltR Results/JUNK_PROCESS/*.dat*
-rw-rw-r-- 1 sergio pi_strow 615920 Feb 23 22:41 Results/JUNK_PROCESS/nlterad_001_000_040.dat
-rw-rw-r-- 1 sergio pi_strow 560548 Feb 23 22:41 Results/JUNK_PROCESS/nlterad_001_000_040.dat_UA
-rw-rw-r-- 1 sergio pi_strow 880788 Feb 23 22:31 Results/JUNK_PROCESS/lterad_001_000_040.dat_UA
-rw-rw-r-- 1 sergio pi_strow 816180 Feb 23 22:31 Results/JUNK_PROCESS/lterad_001_000_040.dat
-rw-rw-r-- 1 sergio pi_strow 816180 Feb 23 22:15 Results/JUNK_PROCESS/usuallterad_001_000_040.dat
%}

progress = ['Results/JUNK_PROCESS/*rad_'  num2str(iProf,'%03d') '_*.dat'];
thedir = dir(progress);
if length(thedir) > 0
  fprintf(1,'   looks like Results/JUNK_PROCESS/ shows progress of %1i other files for iProfile %3i \n',length(thedir),iProf)
  for ii = 1 : length(thedir)
    fprintf(1,'     %40s %10i \n',thedir(ii).name,thedir(ii).bytes)
  end
end
inprogress = length(thedir);

jett = jet; jett(1,:) = 1;
figure(1); clf; imagesc(usual); title([num2str(iProf) ' : Usual LTE']); colorbar; colormap(jett); xlabel('Scanang [1:6 = 0,10,...50]'); ylabel('Solang [1:13 = [00,15,30,...120]'); caxis([0 1]); grid; grid minor; axis([0.5 6.5 1 13]) 
figure(2); clf; imagesc(lte);   title([num2str(iProf) ' : LBL LTE']);   colorbar; colormap(jett); xlabel('Scanang [1:6 = 0,10,...50]'); ylabel('Solang [1:13 = [00,15,30,...120]'); caxis([0 1]); grid; grid minor; axis([0.5 6.5 1 13])
figure(3); clf; imagesc(nlte);  title([num2str(iProf) ' : LBL NLTE']);  colorbar; colormap(jett); xlabel('Scanang [1:6 = 0,10,...50]'); ylabel('Solang [1:13 = [00,15,30,...120]'); caxis([0 1]); grid; grid minor; axis([0.5 6.5 1 13])

fprintf(1,'   check_progress.m : total output files for iProfile = %3i are %3i %3i %3i \n',iProf,[sum(usual(:)) sum(lte(:)) sum(nlte(:))])
