%% cluster_run_nlte_lte SCRIPT
%% adaptation of [nlte,lte] = driver_test_lte_nlte(iProf,solang,scanang,XCO2)
%% see ../emailD.txt
%%  > And 3900 vts files come from [100 profiles x 3 co2 x 13 solar
%%  >  zeniths]. which are 00,15,30,40,50,60,70,80,85,90,95,100,120
%%
%% Main differences : XCO2 is set below, or in the .sbatch file
%%                    output is in Results/Results_CO2_xppmv  (instead of JUNK_PROCESS)
%% see eg 
%%    ../../NONLTE_PRODUCTION/VT_48PROFILES_120_400ppmv_v122_H20_NLTEH16_Feb2025_NewConvolvers_Set001_100
%%    ../../NONLTE_PRODUCTION/VT_48PROFILES_120_400ppmv_v122_H20_NLTEH16_Feb2025_NewConvolvers_Set001_100/mker_results_dirs.sc
%%   in that dir, Results -> /asl/s1/sergio/NLTE_CALCS/VT_48PROFILES_120_SRCv1.22_400ppmv_H16_Mar2025
%%
%% here    mkdir /asl/s1/sergio/NLTE_CALCS/VT_48PROFILES_120_SRCv1.22_400ppmv_H16_Mar2025_Set001_100_415ppmv
%%         ln -s /asl/s1/sergio/NLTE_CALCS/VT_48PROFILES_120_SRCv1.22_400ppmv_H16_Mar2025_Set001_100_415ppmv Results
%%         cp -a ../../NONLTE_PRODUCTION/VT_48PROFILES_120_400ppmv_v122_H20_NLTEH16_Feb2025_NewConvolvers_Set001_100/mker_results_dirs.sc .
%%         mker_results_dirs.sc

%% So depending on JOB we prune out profile, solang and LOOP over scanang
%%  iProf = 1 : 100, scanang = 0,10,20,30,40,50  ==> 600 profiles right there
%%  (prof1,solA   prof1,solB ... prof1,solM)  (prof2,solA   prof2,solB ... prof2,solM)  .... (prof100,solA   prof100,solB ... prof100,solM) 
%%                 [ 1 - 13 ]                             [ 14 - 26]                            ...               [5988 - 6000]
%%  JOB <----> solang + (iProf-1)*100;
%%

%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ mv lte_120km.nml lte_120km_TEST.nml
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ mv nlte_120km.nml nlte_120km_TEST.nml
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ mv usual_lte_120km.nml usual_lte_120km_TEST.nml
%% %
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ cp lte_120km_TEST.nml lte_120km_CLUSTER.nml
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ cp nlte_120km_TEST.nml nlte_120km_CLUSTER.nml
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ cp usual_lte_120km_TEST.nml usual_lte_120km_CLUSTER.nml
%% %
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ ln -s lte_120km_CLUSTER.nml lte_120km.nml
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ ln -s nlte_120km_CLUSTER.nml nlte_120km.nml
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ ln -s usual_lte_120km_CLUSTER.nml usual_lte_120km.nml

%{
Before starting a new cluster job may want to do this

 ls -lt Results/JUNK_PROCESS/
then
 /bin/rm Results/JUNK_PROCESS/*.log
 /bin/rm Results/JUNK_PROCESS/*.nml
 /bin/rm Results/JUNK_PROCESS/*.dat*
 /bin/rm Results/JUNK_PROCESS/*.rtp
 ls -lt Results/JUNK_PROCESS/
then
  kleenslurm; sbatch  --exclude= --array=1-650 sergio_matlab_jobB.sbatch      ## 50 profiles, 13 scanangs = 650 jobs
 this "cluster_run_nlte_lte_001_100.m" actually looks to see if [iProf/solang/scanang] files exists in eg 
    Results/Results_10, Results_lte_usual etc 
  before starting the (laborious) KCARTA LBL runs

Then you can see how many of the 650 are running (maybe because just started looking at them, or they really have holes) by doing eg
  [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ sqrun | wc -l
  avoid asterix avoid asterix avoid
  cpu2021        up   infinite      2    mix cnode[056-057]
  cpu2021        up   infinite      1  alloc cnode058
  cpu2021        up   infinite     11   idle cnode[051-055,059-064]
  high_mem       up   infinite      1  drain cnode040
  high_mem       up   infinite     16    mix bdnode[001,004-008],cnode[003,005-011,022,042]
  high_mem       up   infinite      5  alloc bdnode[002-003],cnode[002,004,043]
  high_mem       up   infinite     26   idle cnode[012-021,023-029,031-039]
  avoid asterix avoid asterix avoid
  336
while this tells you how many have already been done (everything skipped)
  [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ grep -on 'see progress using check_progress' slurm-20968303_* | wc -l
  357

To convolve see eg 
 ../../NONLTE_PRODUCTION/VT_48PROFILES_120_400ppmv_v121_H16_NLTEH16_Mar2020_NewConvolvers/cris_convolve.m
 ../../NONLTE_PRODUCTION/VT_48PROFILES_120_400ppmv_v121_H16_NLTEH16_Mar2020_NewConvolvers/airs_convolve.m
 ../../NONLTE_PRODUCTION/VT_48PROFILES_120_400ppmv_v121_H16_NLTEH16_Mar2020_NewConvolvers/iasi_convolve.m
%}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% this is in /home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/Translate_Manuel2Sergio_F77/driver_test_lte_nlte.m
%            /home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE2/sergio/VT_48PROFILES/driver_test_lte_nlte_umbcprofiles.m
% this version deals with Manuel's Jan 2025 profiles  .. assumes CO2 = 370,415,460 ppm
% driver_test_lte_nlte(1,30,0,370)

addpath /asl/matlib/h4tools
addpath /home/sergio/KCARTA/MATLAB
addpath /home/sergio/MATLABCODE 
addpath /home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/

%% each LBL calc takes about 15 minutes, so 30 minutes per profile/angle
%% there are 6 scanangs so ask or 3 hours on the cluster per JOB
JOB = str2num(getenv('SLURM_ARRAY_TASK_ID'));
if length(JOB) == 0
  JOB = 1;
  % JOB = 2;
  JOB = 665
  JOB = 1300
end

if ~exist('XCO2')
  %% XCO2 could be set by the .sbatch file
  %% if not this is the default setting
  XCO2 = 370;  %% already done Feb 24-27
  XCO2 = 415;   
  XCO2 = 460;   
end

XYZCO2 = XCO2;
if XCO2 == 370
  iCO2 = 1;
elseif XCO2 == 415
  iCO2 = 2;
elseif XCO2 == 460
  iCO2 = 3;
end

iNLTEorLTE = +1; %% do NLTE only, about 12 mins per [prof/scanang/solang]
iNLTEorLTE = -1; %% do LTE  only, about 12 mins per [prof/scanang/solang]
iNLTEorLTE = 0; %% do both, about 25 mins       per [prof/scanang/solang]

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%
thesolang = [00 15 30 40 50 60 70 80 85 90 95 100 120];
iNumProf = (349-201)+1;  %% set 201-349
iNumProf = (200-101)+1;  %% set 101-200
iNumProf = (100-001)+1;  %% set 001-100
%%%%%%%%%%%%%%%%%%%%%%%%%
%% see /home/sergio/MATLABCODE/oem_pkg_run/AIRS_gridded_STM_May2021_trendsonlyCLR/clust_run_retrieval_setlatbin_AIRS_loop_lonbin.m
%% generic
disp('generic test of JOB vs iProf vs solang')
iProf = floor(((1:length(thesolang)*iNumProf)-1)/length(thesolang))+1;
solang = (1:length(thesolang)*iNumProf)-(iProf-1)*length(thesolang);
plot(1:length(solang),iProf)    %% JOB ranges from eg 1-100*13
plot(1:length(solang),solang)   %% JOB ranges from eg 1-100*13

% printarray([iProf(1:30); solang(1:30)]')

%%%%%%%%%%%%%%%%%%%%%%%%%
%% see /home/sergio/MATLABCODE/oem_pkg_run/AIRS_gridded_STM_May2021_trendsonlyCLR/clust_run_retrieval_setlatbin_AIRS_loop_lonbin.m
%% based on JOB
disp(' ')
iProf = floor(((JOB)-1)/length(thesolang))+1;
solangX = (JOB)-(iProf-1)*length(thesolang);
solang = thesolang(solangX);
fprintf(1,'JOB = %4i  ===>>> iProf = %3i  solangindex=%2i --> solang = %2i     iXCO2 = %1i\n \n',JOB,iProf,solangX,solang,iCO2);
%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

f1 = 2105;
f2 = 2505;

ZOF = iProf;

foutdir = 'JUNK_PROCESS';
foutdir = ['Results/JUNK_PROCESS/'];

kcarta = '/home/sergio/KCARTA/BIN/kcarta.x_f77_118_400ppmv_H16_NLTEH16_120NLTElayers_new';
kcarta = '/home/sergio/KCARTA/BIN/kcarta.x_f90_122_400ppmv_H20';

thescanang = [00 10 20 30 40 50];
for ss = 1 : length(thescanang)
  scanang = thescanang(ss);
  
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %%%%% this is now essentially from driver_test_lte_nlte(iProf,solang,scanang,XCO2) %%%%
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  fprintf(1,'processing JOB = %4i : iProf = %3i solzen = %3i scanang = %2i CO2 = %3i ppm\n',JOB,iProf,solang,scanang,XCO2)

  [h,ha,p,pa] = rtpread(['../manuel_jan_2025_' num2str(XYZCO2) '_ppmv.rp.rtp']);

  frtp = [foutdir 'junk_manuel_jan_2025_' num2str(XYZCO2) '_ppmv_' num2str(scanang) '.rp.rtp'];                                                              %% same name for every prof/solzen
  frtp = [foutdir 'junk_manuel_jan_2025_' num2str(XYZCO2) '_ppmv_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.rp.rtp'];  %% this is more unique
  frtp = [foutdir 'junk_manuel_jan_2025_' num2str(XYZCO2) '_ppmv_' num2str(iProf) '_' num2str(solang) '_' num2str(scanang) '.rp.rtp'];                       %% this is more unique

  p.solzen  = ones(size(p.scanang)) * solang;
  p.zobs    = ones(size(p.scanang)) * 705000;
  p.scanang = ones(size(p.scanang)) * scanang;
  p.satzen = vaconv(p.scanang, p.zobs, zeros(size(p.zobs)));
  rtpwrite(frtp,h,ha,p,pa)
  if ~exist(frtp)
    fprintf(1,'OH NO annot find %s \n',frtp)
    return
  else
    disp(' ')
    lser = ['!ls -lt ' frtp];
    eval(lser)
  end
  
  sedder = ['!sed -e "s/FF1/' num2str(f1) '/g"  -e "s/FF2/' num2str(f2) '/g" '];               %% wn1,wn2
  sedder = [sedder ' -e "s/ZOF/' num2str(iProf) '/g" '];                                       %% profile
  sedder = [sedder ' -e "s/SSS/' num2str(scanang) '/g" '];                                     %% scanang
  sedder = [sedder ' -e "s/SOL/' num2str(solang) '/g" '];                                      %% solzen
  sedder = [sedder ' -e "s/XYZCO2/' num2str(XYZCO2) '/g"  -e "s/iCO2/' num2str(iCO2) '/g" '];  %% co2 ppmv
  
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  if iNLTEorLTE == 0 | iNLTEorLTE == -1
    usuallte_nml = [foutdir 'usualltejunk_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.nml'];
    usuallte_out = [foutdir 'usuallterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
    booXY        = ['usuallterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
    lte_outXY    = ['Results/Results_lte_Usual/' booXY];
    if ~exist(lte_outXY)
      sedderX = [sedder ' usual_lte_120km.nml > ' usuallte_nml];
      fprintf(1,'LTE sedder = %s \n',sedderX)
      eval(sedderX)
      kcartaer = ['!time ' kcarta ' ' usuallte_nml ' ' usuallte_out];
      fprintf(1,'USUAL LTE kcartaer = %s \n',kcartaer)
      eval(kcartaer)
    else
      fprintf(1,'usuallte_out = %s already exists, SKIPPING \n',lte_outXY);
      lser = ['!ls -lt ' lte_outXY];
      eval(lser)
    end

    lte_nml   = [foutdir 'ltejunk_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.nml'];
    lte_out   = [foutdir 'lterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
    booXY     = ['lterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
    lte_outXY = ['Results/Results_lte_Rhead/' booXY];
    if ~exist(lte_outXY)
      sedderX = [sedder ' lte_120km.nml > ' lte_nml];
      fprintf(1,'LTE sedder = %s \n',sedderX)
      eval(sedderX)
      kcartaer = ['!time ' kcarta ' ' lte_nml ' ' lte_out];
      fprintf(1,'LTE kcartaer = %s \n',kcartaer)
      eval(kcartaer)
    else
      fprintf(1,'lte_out = %s already exists, SKIPPING \n',lte_outXY);
      lser = ['!ls -lt ' lte_outXY];
      eval(lser)
    end
  end
  
  if iNLTEorLTE == 0 | iNLTEorLTE == +1
    nlte_nml   = [foutdir 'nltejunk_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.nml'];
    nlte_out   = [foutdir 'nlterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
    booXY      = ['nlterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
    nlte_outXY = ['Results/Results_' num2str(scanang) '/' booXY];
    if ~exist(nlte_outXY)
      sedderX = [sedder ' nlte_120km.nml > ' nlte_nml];
      fprintf(1,'NLTE sedder = %s \n',sedderX)
      eval(sedderX)
      kcartaer = ['!time ' kcarta ' ' nlte_nml ' ' nlte_out];
      fprintf(1,'NLTE kcartaer = %s \n',kcartaer)
      eval(kcartaer)
    else
      fprintf(1,'nlte_out = %s already exists, SKIPPING \n',nlte_outXY);
      lser = ['!ls -lt ' nlte_outXY];
      eval(lser)
    end
  end

  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %%%%% this is now essentially from driver_test_lte_nlte(iProf,solang,scanang,XCO2) %%%%
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  logN = [foutdir '/nlte_' num2str(iProf) '_' num2str(solang) '_' num2str(scanang) '.log'];
  logL = [foutdir '/lte_' num2str(iProf) '_' num2str(solang) '_' num2str(scanang) '.log'];
  logU = [foutdir '/usuallte_' num2str(iProf) '_' num2str(solang) '_' num2str(scanang) '.log'];

  disp(' ')
  rmer = ['!/bin/rm ' nlte_nml ' ' lte_nml ' ' usuallte_nml ' ' logN ' ' logL ' ' logU ' ' frtp];
  eval(rmer);

  if iNLTEorLTE == 0 | iNLTEorLTE == -1
    lte_outX = ['Results/Results_lte_Usual/.'];
    mver = ['!/bin/mv '  usuallte_out '*  ' lte_outX];
    eval(mver)

    lte_outX = ['Results/Results_lte_Rhead/.'];
    mver = ['!/bin/mv '  lte_out '*  ' lte_outX];
    eval(mver)
  end

  if iNLTEorLTE == 0 | iNLTEorLTE == +1
    nlte_outX = ['Results/Results_' num2str(scanang) '/.'];
    mver = ['!/bin/mv '  nlte_out '*  ' nlte_outX];
    eval(mver)
  end

  fprintf(1,'<<<<<<<<<<<<<<<<<<<<<<<<<  finished with ss = %2i of %2i scanang = %2i >>>>>>>>>>>>>>>>>>>>> \n',ss,length(thescanang),scanang)
end  

disp('see progress using check_progress.m')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

iPlot = -1;
if iPlot > 0
  %% this will really only work for the lat profile run off

  [dusual,w] = readkcstd(usuallte_out);
  [dlte  ,w]  = readkcstd(lte_out);
  [dnlte ,w]  = readkcstd(nlte_out);
  
  [fc,qc] = quickconvolve(w,[dusual dlte dnlte],1,1);
  tc = rad2bt(fc,qc);
  figure(1); clf
    plot(fc,tc)
    plot(fc,tc(:,2)-tc(:,1),'b.-',fc,tc(:,3)-tc(:,1),'r')
  
  theNLTEprof = ['../Set001_100/Sergio_vt_profs_1_100/sergio_merge/NLTE/vt' num2str(ZOF) '_s' num2str(solang) '_co2_' num2str(iCO2) '.prf'];
  dirIN = '../Set001_100/Sergio_vt_profs_1_100/';
  iSol = solang;
  ii = ZOF;
    [dataVT,dataVMR,dataVTS] = read_manuel_pt_vmr_vts(dirIN,ii,iSol,iCO2);
  
  %% see ../driver_compare_vts_new.m
  press = -5:0.1:3;
  press = 10.^press;
    dataVTS.P = interp1(dataVT.Z,dataVT.P,dataVTS.Z);
    tkinetic = interp1(log(dataVT.P),dataVT.T,log(press),[],'extrap');
  
    ix = find(dataVTS.hitranL == 21 & dataVTS.hitranU == 9);  %% 2349 cm-1
    tvib2350 = interp1(log(dataVTS.P),dataVTS.tvib(ix,:),log(press),[],'extrap');
  
  figure(2); clf
    semilogy(tvib2350-tkinetic,press); set(gca,'ydir','reverse'); ylim([1e-5 1e3]); plotaxis2;
    title('2349 cm-1 strong band'); xlabel('Tvib-Tkinetic [K]'); ylabel('Press [mb]')
end
