function [nlte,lte] = compare_March2020_umbc_VTS_against_Jan2025(iProf,solang,scanang,XCO2)

% this is reading results from /home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/Translate_Manuel2Sergio_F77/driver_test_lte_nlte.m
%                              /home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE2/sergio/VT_48PROFILES/driver_test_lte_nlte_umbcprofiles.m
% compare_March2020_umbc_VTS_against_Jan2025(1,30,0,370)

addpath /asl/matlib/h4tools
addpath /home/sergio/KCARTA/MATLAB
addpath /home/sergio/MATLABCODE 
addpath /home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/

if nargin == 3
  XCO2 = 400;
end

f1 = 2105;
f2 = 2505;

ZOF = iProf;

XYZCO2 = XCO2;
if XCO2 == 370
  iCO2 = 1;
elseif XCO2 == 415
  iCO2 = 2;
elseif XCO2 == 460
  iCO2 = 3;
end

frtp = ['JUNK_PROCESS/junk_manuel_jan_2025_' num2str(XYZCO2) '_ppmv_' num2str(scanang) '.rp.rtp'];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

usuallte_out = ['JUNK_PROCESS/usuallterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
lte_out = ['JUNK_PROCESS/lterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
nlte_out = ['JUNK_PROCESS/nlterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];

[dusualN,w] = readkcstd(usuallte_out);
[dlteN  ,w]  = readkcstd(lte_out);
[dnlteN ,w]  = readkcstd(nlte_out);

theNLTEprof = ['../Set001_100/Sergio_vt_profs_1_100/sergio_merge/NLTE/vt' num2str(ZOF) '_s' num2str(solang) '_co2_' num2str(iCO2) '.prf'];
dirIN = '../Set001_100/Sergio_vt_profs_1_100/';
iSol = solang;
ii = ZOF;
  [dataVT,dataVMR,dataVTS] = read_manuel_pt_vmr_vts(dirIN,ii,iSol,1);

%% see ../driver_compare_vts_new.m
press = -5:0.1:3;
press = 10.^press;
  dataVTS.P = interp1(dataVT.Z,dataVT.P,dataVTS.Z);
  tkinetic = interp1(log(dataVT.P),dataVT.T,log(press),[],'extrap');

  ix = find(dataVTS.hitranL == 21 & dataVTS.hitranU == 9);  %% 2349 cm-1
  tvib2350 = interp1(log(dataVTS.P),dataVTS.tvib(ix,:),log(press),[],'extrap');

figure(5); clf
  semilogy(tvib2350-tkinetic,press); set(gca,'ydir','reverse'); ylim([1e-5 1e3]); plotaxis2;
  title('2349 cm-1 strong band'); xlabel('Tvib-Tkinetic [K]'); ylabel('Press [mb]')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

usuallte_out = ['/home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE2/sergio/VT_48PROFILES/JUNK_PROCESS/usuallterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
lte_out = ['/home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE2/sergio/VT_48PROFILES/JUNK_PROCESS/lterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
nlte_out = ['/home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE2/sergio/VT_48PROFILES/JUNK_PROCESS/nlterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];

[dusual0,w] = readkcstd(usuallte_out);
[dlte0  ,w]  = readkcstd(lte_out);
[dnlte0 ,w]  = readkcstd(nlte_out);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[fc,qc0] = quickconvolve(w,[dusual0 dlte0 dnlte0],1,1);
tc0 = rad2bt(fc,qc0);
[fc,qcN] = quickconvolve(w,[dusualN dlteN dnlteN],1,1);
tcN = rad2bt(fc,qcN);

figure(1); clf
  plot(fc,tc0)
  plot(fc,tc0(:,2)-tc0(:,1),'b.-',fc,tc0(:,3)-tc0(:,1),'r')
  title('2020 diffs')
hold on
   plot(fc,tcN(:,2)-tcN(:,1),'g.-',fc,tcN(:,3)-tcN(:,1),'k')
  title('2020 and 2025 diffs')
hold off

%figure(2); clf
%  plot(fc,tcN)
%  plot(fc,tcN(:,2)-tcN(:,1),'c.-',fc,tcN(:,3)-tcN(:,1),'m')
%  title('2025 diffs')

figure(3)
plot(fc,tcN-tc0)
  title('2025-2020 diffs : Calc-Calc')
  plotaxis2;
  legend('usual fast LTE','LTE calculated','NLTE calculted','location','best');

figure(4)
plot(fc,(tcN(:,3)-tcN(:,1)) - (tc0(:,3)-tc0(:,1)))
  title('2025-2020 diffs : delta NLTE')
  plotaxis2;
