function [delta2021,delta2025,theangles] = compare_NLTE_LTE_Mar2025_vs_Apr2021(iProf,iCO2,iPlot);

apr2021_dir = '/umbc/xfs2/strow/asl/s1/sergio/home/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE_PRODUCTION/VT_48PROFILES_120_400ppmv_v121_H16_NLTEH16_Apr2021_NewNLTEProfiles_SAVETHISGOOD//Results/CONV_Results/';
apr2021_dir = '/home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE_PRODUCTION/VT_48PROFILES_120_400ppmv_v121_H16_NLTEH16_Apr2021_NewNLTEProfiles_SAVETHISGOOD//Results/CONV_Results/';

if nargin == 1
  iCO2 = 415;
end

mar2025_dir = '/umbc/xfs2/strow/asl/s1/sergio/home/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/PRODUCTION_VT_48PROFILES_120_400ppmv_v122_H20_NLTEH16_Feb2025_NewConvolvers_Set001_100/';
mar2025_dir = '/home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/PRODUCTION_VT_48PROFILES_120_400ppmv_v122_H20_NLTEH16_Feb2025_NewConvolvers_Set001_100/';
mar2025_dir = [mar2025_dir '/Results' num2str(iCO2) '/CONV_Results/'];

iProf_apr2021 = iProf;
if iProf > 48
  disp('Warning : only have 48 profiles for Apr 2021, so using Profile 1 there')
  iProf_apr2021 = 1;
end
apr2021 = load([apr2021_dir 'vt' num2str(iProf_apr2021) '.mat']);
mar2025 = load([mar2025_dir 'vt' num2str(iProf)         '.mat']);

solang_apr2021 = unique(apr2021.solar);
solang_mar2025 = unique(mar2025.solar);
va = 0:10:50;

[Y,i2021,i2025] = intersect(solang_apr2021,solang_mar2025);
iCnt = 0;
for vv = 1 : length(va)
  for sol = 1 : length(Y)
    iCnt = iCnt + 1;
    common_apr2021(iCnt) = find(apr2021.solar == Y(sol) & apr2021.viewer == va(vv));
    common_mar2025(iCnt) = find(mar2025.solar == Y(sol) & mar2025.viewer == va(vv));
    theangles.sol(vv,sol) = Y(sol);
    theangles.va(vv,sol) = va(vv);
    theangles.freq = mar2025.fairs;
  end
end

%% Chris says for all sensors, he uses  : lte_iasi_Bfunny4um and nlte_iasiB etc

lteA_apr2021  = apr2021.lte_airs_Bfunny4um(:,common_apr2021); 
nlteA_apr2021 = apr2021.nlte_airsB(:,common_apr2021); 
tlteA_apr2021  = rad2bt(apr2021.fairs,lteA_apr2021);
tnlteA_apr2021 = rad2bt(apr2021.fairs,nlteA_apr2021);

lteA_mar2025  = mar2025.lte_airs_Bfunny4um(:,common_mar2025); 
nlteA_mar2025 = mar2025.nlte_airsB(:,common_mar2025); 
tlteA_mar2025  = rad2bt(mar2025.fairs,lteA_mar2025);
tnlteA_mar2025 = rad2bt(mar2025.fairs,nlteA_mar2025);

figure(1); plot(mar2025.fairs,tlteA_apr2021,'b',mar2025.fairs,tlteA_mar2025,'r'); title('LTE')
figure(2); plot(mar2025.fairs,tnlteA_apr2021,'b',mar2025.fairs,tnlteA_mar2025,'r'); title('NLTE')
figure(3); plot(mar2025.fairs,tnlteA_apr2021-tlteA_apr2021,'b',mar2025.fairs,tnlteA_mar2025-tlteA_mar2025,'r'); title('NLTE-LTE')
figure(4); plot(mar2025.fairs,(tnlteA_mar2025-tlteA_mar2025)-(tnlteA_apr2021-tlteA_apr2021)); title('(NLTE-LTE 2025) - (NLTE-LTE 2021)')

delta2021 = tnlteA_apr2021-tlteA_apr2021;
delta2025 = tnlteA_mar2025-tlteA_mar2025;

[mm,nn] = size(delta2021);
[mmx,nnx] = size(theangles.va);
delta2021 = reshape(delta2021,mm,nnx,mmx);
delta2025 = reshape(delta2025,mm,nnx,mmx);

if nargin == 2
  iPlot = -1;
end
if iPlot > 0
  ii = find(mar2025.fairs >= 2350,1);
  figure(5); clf; colormap(jet);  pcolor(theangles.sol',theangles.va',squeeze(delta2021(ii,:,:)));                   colorbar; xlabel('Solang'); ylabel('Scanang'); shading interp; title('BT2350 2021')
  figure(6); clf; colormap(jet);  pcolor(theangles.sol',theangles.va',squeeze(delta2025(ii,:,:)));                   colorbar; xlabel('Solang'); ylabel('Scanang'); shading interp; title('BT2350 2025')
  figure(7); clf; colormap(usa2); pcolor(theangles.sol',theangles.va',squeeze(delta2025(ii,:,:)-delta2021(ii,:,:))); colorbar; xlabel('Solang'); ylabel('Scanang'); shading interp; title('BT2350 2025-2021'); caxis([-1 +1])
end
