addpath /asl/matlib/h4tools
addpath /asl/matlib/aslutil
addpath /home/sergio/MATLABCODE

dir0 = '/asl/rtp/airs/airs_l1c_v672/clear/';
for dd = 1:45:360
  file0 = [dir0 '/2003/era_airicrad_day' num2str(dd,'%03d') '_clear.rtp'];
  file1 = [dir0 '/2021/ecmwf_airicrad_day' num2str(dd,'%03d') '_clear.rtp'];
  if exist(file0) & exist(file1)
    [h0,ha,p0,pa] = rtpread(file0);
    [h1,ha,p1,pa] = rtpread(file1);
    
    boo0_D = find(abs(p0.rlat) < 30 & p0.solzen < 060);
    boo0_N = find(abs(p0.rlat) < 30 & p0.solzen > 120);
    r0D = p0.robs1(:,boo0_D);
    r0N = p0.robs1(:,boo0_N);
    t0D = rad2bt(h0.vchan,p0.robs1(:,boo0_D));
    t0N = rad2bt(h0.vchan,p0.robs1(:,boo0_N));
    
    boo1_D = find(abs(p1.rlat) < 30 & p1.solzen < 060);
    boo1_N = find(abs(p1.rlat) < 30 & p1.solzen > 120);
    r1D = p1.robs1(:,boo1_D);
    r1N = p1.robs1(:,boo1_N);
    t1D = rad2bt(h1.vchan,p1.robs1(:,boo1_D));
    t1N = rad2bt(h1.vchan,p1.robs1(:,boo1_N));
    
    %% whos t* r*
    
    figure(1); plot(h1.vchan,nanmean(r0N,2),'b',h1.vchan,nanmean(r1N,2),'r'); ylabel('rad'); xlim([2200 2400]); title('Night Obs');
    figure(2); plot(h1.vchan,nanmean(r0D,2),'b',h1.vchan,nanmean(r1D,2),'r'); ylabel('rad'); xlim([2200 2400]); title('Day   Obs');
    figure(3); plot(h1.vchan,nanmean(r0D,2)-nanmean(r0N,2),'b',h1.vchan,nanmean(r1D,2)-nanmean(r1N,2),'r'); ylabel('\delta rad'); xlim([2200 2400]); title('Day-Night   Obs');
    figure(4); plot(h1.vchan,(nanmean(r1D,2)-nanmean(r1N,2))-(nanmean(r0D,2)-nanmean(r0N,2)));              ylabel('\delta rad'); xlim([2200 2400]); title('Day-Night Obs 2021-2003'); plotaxis2;
    figure(1); set(gca,'fontsize',12);
    figure(2); set(gca,'fontsize',12);
    figure(3); set(gca,'fontsize',12);
    figure(4); set(gca,'fontsize',12);
    
    figure(1); plot(h1.vchan,nanmean(t0N,2),'b',h1.vchan,nanmean(t1N,2),'r'); ylabel('BT [K]'); xlim([2200 2400]); title('Night Obs');
    figure(2); plot(h1.vchan,nanmean(t0D,2),'b',h1.vchan,nanmean(t1D,2),'r'); ylabel('BT [K]'); xlim([2200 2400]); title('Day   Obs');
    figure(3); plot(h1.vchan,nanmean(t0D,2)-nanmean(t0N,2),'b',h1.vchan,nanmean(t1D,2)-nanmean(t1N,2),'r'); ylabel('\delta BT [K]'); xlim([2200 2400]); title('Day-Night   Obs');
    figure(4); plot(h1.vchan,(nanmean(t1D,2)-nanmean(t1N,2))-(nanmean(t0D,2)-nanmean(t0N,2)));              ylabel('\delta BT [K]'); xlim([2200 2400]); title('Day-Night Obs 2021-2003'); plotaxis2;
    figure(1); set(gca,'fontsize',12);
    figure(2); set(gca,'fontsize',12);
    figure(3); set(gca,'fontsize',12);
    figure(4); set(gca,'fontsize',12);

    figure(5); plot(h1.vchan,nanmean(t1N,2)-nanmean(t0N,2),'b',h1.vchan,nanmean(t1D,2)-nanmean(t0D,2),'r'); plotaxis2; title('2021-2003 (B) Night (R) Day')
    figure(5); set(gca,'fontsize',12);
    figure(6); plot(h1.vchan,nanmean(t1N,2)-nanmean(t0N,2),'b',h1.vchan,nanmean(t1D,2)-nanmean(t0D,2),'r'); xlim([2200 2400]); plotaxis2; title('2021-2003 (B) Night (R) Day')
    figure(6); set(gca,'fontsize',12);

    fprintf(1,'this was day %3i \n',dd);
    pause
  else
    fprintf(1,'one or both files not abailable for day %3i \n',dd);
  end
end
