function compare_calcs_Jan2025_profiles_differentco2(iProf,solang,scanang,XCO2A,XCO2B0)

addpath /asl/matlib/h4tools
addpath /asl/matlib/aslutil
addpath /home/sergio/KCARTA/MATLAB
addpath /home/sergio/MATLABCODE

%% driver_test_lte_nlte(1,30,0,370)
%% driver_test_lte_nlte(1,30,0,415)
%% compare_calcs_Jan2025_profiles_differentco2(1,30,0,370,415);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dir1 = ['JUNK_PROCESS/' num2str(XCO2A,'%03d') '/'];  %% eg 370 ppm
if nargin == 5
  dir2 = ['JUNK_PROCESS/' num2str(XCO2B0,'%03d') '/'];  %% eg 415 ppm
else
  error('need two CO2 ppmv')
  dir2 = ['JUNK_PROCESS/'];  %% latest run
end

if XCO2B0 == XCO2A + 1
  XCO2B = XCO2A;   %% eg 370,371 ppmv
else
  XCO2B = XCO2B0;  %% eg 370,415 ppmv
end

[h1,ha,p1,pa] = rtpread([dir1 '/junk_manuel_jan_2025_' num2str(XCO2A,'%03d') '_ppmv_' num2str(scanang) '.rp.rtp']);
[h2,ha,p2,pa] = rtpread([dir2 '/junk_manuel_jan_2025_' num2str(XCO2B,'%03d') '_ppmv_' num2str(scanang) '.rp.rtp']);

figure(1); semilogy(p1.gas_1./p2.gas_1,p1.plevs,'b.-',p1.gas_2./p2.gas_2,p1.plevs,'gx-',p1.gas_3./p2.gas_3,p1.plevs,'r');
  xlim([0.8 1.2]); legend('WV','CO2','O3','location','best'); ylabel('P[mb]'); set(gca,'ydir','reverse'); ylim([0 1000])
  title('Gas Amount Ratios')

figure(2); semilogy(p1.ptemp - p2.ptemp,p1.plevs,'r');
  title('T(z) differences')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% see convolve_rad_results_nobloat_main_code.m
[dusual1,w] = readkcstd([dir1 '/usuallterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat']);
[dusual2,w] = readkcstd([dir2 '/usuallterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat']);

%%%%%%%%%%%%%%%%%%%%%%%%%
[dlte1,w] = readkcstd([dir1 '/lterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat']);
[dlte2,w] = readkcstd([dir2 '/lterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat']);

[dlteUA1,wx] = readkcUA([dir1 '/lterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat_UA']);
[dlteUA2,wx] = readkcUA([dir2 '/lterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat_UA']);

dlteUA1 = dlteUA1(:,2);
dlteUA2 = dlteUA2(:,2);

%%%%%%%%%%%%%%%%%%%%%%%%%
[dnlte1,w] = readkcstd([dir1 '/nlterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat']);
[dnlte2,w] = readkcstd([dir2 '/nlterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat']);

[dnlteUA1,wx] = readkcUA([dir1 '/nlterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat_UA']);
[dnlteUA2,wx] = readkcUA([dir2 '/nlterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat_UA']);

dnlteUA1 = dnlteUA1(:,2);
dnlteUA2 = dnlteUA2(:,2);

moo = find(w >= wx(1)-0.0025/2 & w < wx(end)+0.0025/2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(6); 
  subplot(211); plot(w,rad2bt(w,dusual1),'b.-',w,rad2bt(w,dusual2),'r'); xlim([2350 2351])
    title('USUAL 80 km  mono (b)co2A (r) co2B')
  subplot(212); plot(w,rad2bt(w,dusual2) -rad2bt(w,dusual1)); xlim([2350 2351])
    title('USUAL mono co2B - co2A')

figure(7); 
  subplot(211); plot(w,rad2bt(w,dlte1),'b.-',w,rad2bt(w,dlte2),'r'); xlim([2350 2351])
    title('LTE 80 km mono (b)co2A (r) co2B')
  subplot(212); plot(w,rad2bt(w,dlte2) -rad2bt(w,dlte1)); xlim([2350 2351])
    title('LTE mono co2B - co2A')

figure(8); 
  subplot(211); plot(wx,rad2bt(wx,dnlteUA1),'b.-',wx,rad2bt(wx,dnlteUA2),'r'); xlim([2350 2351])
    title('NLTE 120 km mono (b)co2A (r) co2B')
  subplot(212); plot(wx,rad2bt(wx,dnlteUA2) -rad2bt(wx,dnlteUA1)); xlim([2350 2351])
    title('NLTE mono co2B - co2A')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[fc,qc] = quickconvolve(wx,[dusual1(moo) dlte1(moo) dlteUA1 dusual2(moo) dlte2(moo) dlteUA2     dnlte1(moo) dnlteUA1 dnlte2(moo) dnlteUA2],1,1);
tc = rad2bt(fc,qc);

figure(3); plot(fc,tc(:,1:3),fc,tc(:,4:6),'--'); title('LTE')
figure(3); plot(fc,tc(:,4:6) - tc(:,1:3)); title('LTE diff B-A')
  plotaxis2; legend('usual','80 km','120 km','location','best','fontsize',10)

figure(4); plot(fc,tc(:,7:8),fc,tc(:,9:10),'--'); title('LTE')
figure(4); plot(fc,tc(:,9:10) - tc(:,7:8)); title('NLTE diff B-A')
  plotaxis2; legend('80 km','120 km','location','best','fontsize',10)

%% we use dlte and dnlteUA
figure(5); plot(fc,tc(:,[2 5]),fc,tc(:,[8 10]),'--'); title('LTE and NLTE')
figure(5); plot(fc,tc(:,[8 10]) - tc(:,[2 5])); title('NLTE-LTE  diff A vs B')
  plotaxis2; legend('A CO2 ppm','B CO2 ppm','location','best','fontsize',10)
figure(5); plot(fc,(tc(:,10)-tc(:,5))-(tc(:,8)-tc(:,2))); title('NLTE-LTE  diff A vs diff B')
  plotaxis2; legend('A CO2 ppm','B CO2 ppm','location','best','fontsize',10)

