sol = [0 40 60 80 85 90 120];

ppK = [3];            %% kinetic profile
ppQV = [4];           %% QV profile to study
ppNLTE = [8 12 14];   %% NLTE profile to study

cd TEST_POLYFIT

for jj = 1 : 1
  for ii = 1 : 48
    f1 = ['a = load(''../sergio_merge/vt' num2str(ii) '_s' ];
    f1 = [f1 num2str(sol(jj)) '.sss'');'];
    eval(f1);
    press(ii,:)   = a(:,2);
    kinetic(ii,:) = a(:,3);
    end
  end
meanP = mean(press);
meanT = mean(kinetic);

iS = 0;
for jj = 1 : 6
  for ii = 1 : 48
    iS = iS + 1;
    f1 = ['a = load(''../sergio_merge/vt' num2str(ii) '_s' ];
    f1 = [f1 num2str(sol(jj)) '.sss'');'];
    eval(f1);

    f2 = ['b = load(''res' num2str(iS) '.dat_VT' num2str(ii) '.sss'');'];
    eval(f2);    

    fprintf(1,'%3i %3i \n',jj,ii);
    str = ['prof ' num2str(ii)  ' solang ' num2str(jj)];

    figure(1)
    subplot(131);
      semilogy(a(:,3),a(:,2),'.-',b(:,3),b(:,2),'ro-');
      axis([150 350 1e-3 1100]); grid on
    subplot(132);
      semilogy(a(:,ppNLTE),a(:,2),'b.-',b(:,ppNLTE),b(:,2),'ro-');
      axis([150 350 1e-3 1100]); grid on
      title(str);
    subplot(133);
      semilogy(a(:,ppQV),a(:,2),b(:,ppQV),b(:,2),'r'); 
      axis([0.9 1.1 1e-3 1100]); grid on

    figure(2)
    subplot(141);
      semilogy(a(:,3),a(:,2),'.-',meanT,meanP,'r.-');
      axis([150 350 1e-3 1100]); grid on
    subplot(142);
      yyK = interp1(log(b(:,2)),b(:,3),log(a(:,2)));      
      dK(iS,:) = a(:,3) - yyK;
      semilogy(dK(iS,:),a(:,2),'.')
      axis([-10 10 1e-3 1100]); grid on
    subplot(143);
      yyT = interp1(log(b(:,2)),b(:,ppNLTE),log(a(:,2)));      
      dT(iS,:,:) = a(:,ppNLTE) - yyT;
      semilogy(squeeze(dT(iS,:,:)),a(:,2),'.')
      axis([-10 10 1e-3 1100]); grid on
      title(str);
    subplot(144);
      yyQV = interp1(log(b(:,2)),b(:,ppQV),log(a(:,2)));      
      dQV(iS,:,:) = a(:,ppQV) - yyQV;
      semilogy(squeeze(dQV(iS,:,:)),a(:,2),'.')
      axis([-0.1 0.1 1e-3 1100]); grid on

    pause(1);
    end
  end

%%% now do stats
figure(3);

stats_dT1 = squeeze(dT(:,:,1));
stats_dT2 = squeeze(dT(:,:,2));
stats_dT3 = squeeze(dT(:,:,3));

deltaT = -10:0.25:10;
yyT1 = hist(stats_dT1,deltaT); plot(deltaT,yyT1,'.-')
yyT2 = hist(stats_dT2,deltaT); plot(deltaT,yyT2,'.-')
yyT3 = hist(stats_dT3,deltaT); plot(deltaT,yyT3,'.-')
