%this script file compares the NLTE profiles made by Manuel against those
%sent to him from make_prof_puertas1; we basically dump stuff into PUERTAS2
%and read stuff from sergio_merge_works

%%this is basically code from make_prof_puertas2 (make_prof_puertas1 does not
%%put pressure onto a log scale).

%needs, to run his NLTE VT code
% they should be in the following format, and preferably
% a) interpolated to a 1 km grid
% b) extend to 120 km

%%% look at /home/sergio/RTPprof
%%% use /asl/packages/sartaV104/Test/reg_op.rtp

fin = '/asl/packages/sartaV104/Test/reg_op.rtp';
[h,ha,p,pa] = rtpread(fin);

nlevs = p.nlevs;
zh    = (p.palts(1:100,:) + p.palts(2:101,:))/2;
press = p.plays;
temp  = p.ptemp;

iLog = -1;   %%use P scale
iLog = +1;   %%use logP scale

for ii = 1 : 48
  numlay          = nlevs(ii) - 1;
  heights         = zh(1:numlay,ii)/1000;
  if iLog > 0
    pressure_layers = log10(press(1:numlay,ii));
  else
    pressure_layers = (press(1:numlay,ii));
    end
  temp_layers     = temp(1:numlay,ii);

  max_ht      = max(heights);
  min_ht      = min(heights);
  new_mx_ht   = floor(max_ht);
  new_mn_ht   = 0.0;
  height_axis = new_mn_ht : 1 : new_mx_ht;

  pressure_axis = interp1(heights,pressure_layers,height_axis,[],'extrap');
  if iLog > 0  
    pressure_axis = 10.^(pressure_axis);
    end
  temp_axis     = interp1(heights,temp_layers,height_axis,[],'extrap');

  fname = '/home/sergio/KCARTA/SRC/NONLTE2/';
  fname = [fname 'sergio/VT_48PROFILES/sergio_merge/'];
  fname = [fname 'vt' num2str(ii) '_s0.sss'];
  manuel = load(fname);

  semilogx(press(:,ii),temp(:,ii),'.-',...
           pressure_axis,temp_axis,'.-',manuel(:,2),manuel(:,[3 4]),'.-');
  axis([min(min(press)) max(max(press)) 175 350]);
  legend('regr','1 km res','kinetic','sigsig',0);
  str = num2str(ii); title(str); grid on

  pause;
  end

hold off