function cp_400ppm_2_xppm_manuel_Jan2025(rPPM);

addpath /asl/matlib/h4tools
addpath /home/sergio/MATLABCODE
addpath /home/sergio/MATLABCODE/CONVERT_GAS_UNITS

cd /asl/data/kcarta_sergio/KCDATA/NLTE/LA/

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dir0 = '/home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/PRODUCTION_VT_48PROFILES_120_400ppmv_v122_H20_NLTEH16_Feb2025_NewConvolvers_Set001_100/';
dir0 = '/home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/';

a = load('us_std_prof_la_400ppmv');

%% rPPM = input('Enter ppm you want to convert to (from 400 ppm) : ');
if length(intersect(rPPM,[370 415 460])) == 0
  rPPM
  error('can only do 370, 415, 460 ppmv!!!')
end

fin = [dir0 '/manuel_jan_2025_' num2str(rPPM) '_ppmv.rp.rtp'];
if ~exist(fin)
  fprintf(1,'%s DNE \n',fin);
  error('lskjfslkjf')
end

[h,ha,p,pa] = rtpread(fin);
p = make_rtp_plays(p);
co2ppm = layers2ppmv(h,p,1:length(p.stemp),2);
[mm0,nn] = size(co2ppm);
for mm = mm0+1 : 101
  co2ppm(mm,:) = co2ppm(mm0,:);
end

%moo = p.plays; whos moo
%moo = p.ptemp; whos moo
%moo = co2ppm;  whos moo

nlays_prof49 = p.nlevs(49) - 1;

a = [(fliplr(1 : 101))' p.plays(:,49) p.plays(:,49).*co2ppm(:,49) p.ptemp(:,49) p.gas_2(:,49)/6.023e26];
a(:,[2 3]) = a(:,[2 3])/1013.25;  %% mb2atm
a = flipud(a);

a0 = load('/asl/data/kcarta_sergio/KCDATA/NLTE/LA/us_std_prof_la_400ppmv','-ascii');
a(1:101-nlays_prof49,2:5) = a0(1:101-nlays_prof49,2:5);
a(1:101-nlays_prof49,5) = a0(1:101-nlays_prof49,5) * rPPM/400;

fnameout = ['us_std_prof_la_' num2str(rPPM) 'ppmv_manuel_jan2025'];
if ~exist(fnameout)
  fid = fopen(fnameout,'w');
  fprintf(fid,'%3i %12.8e %12.8e %12.8f %12.8e \n',a');
  fclose(fid);
  figure(1); semilogy(a0(:,4),a0(:,2)*1013.25,a(:,4),a(:,2)*1013.25); ylim([1 1000]); set(gca,'ydir','reverse'); title('T(z) [K]');
  figure(2); semilogy(a0(:,5),a0(:,2)*1013.25,a(:,5),a(:,2)*1013.25); ylim([1 1000]); set(gca,'ydir','reverse'); title('Q(z) kmoles/cm2');
else
  fprintf(1,'/asl/data/kcarta_sergio/KCDATA/NLTE/LA/%s already exists \n',fnameout);
  disp('not doing that ppmv again!!!')  
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cd /home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/PRODUCTION_VT_48PROFILES_120_400ppmv_v122_H20_NLTEH16_Feb2025_NewConvolvers_Set001_100
