figure(5); clf
[h,ha,ppp,pa] = rtpread('rtp_regress.op.rtp');
clear tdiffer_solar;

tdiffer_solar = [];

for ii = 1 : 48

  %%%%%%%%%%%%%%% radiances
  loader = ['load Results/vt' num2str(ii) '_rad.mat'];
  eval(loader);

  str = num2str(ii);

  figure(1)
  subplot(211)
  plot(fout,rad2bt(fout,nlte_airs)); title(['radiances ' str])
  subplot(212)
  tdiff = rad2bt(fout,nlte_airs) - rad2bt(fout,lte_airs);
  plot(fout,tdiff);

  jj = find(fout >= 2348); jj= jj(1);
  tdiffer(ii) = tdiff(jj,1);
  tdiffer_solar = [tdiffer_solar tdiff(jj,1:5:28)];

  %%%%%%%%%%%%%%% planck
  loader = ['load Results/vt' num2str(ii) '_PLANCK.mat'];
  eval(loader);
  
  figure(2)
  plot(fout,squeeze(plk_airs(:,:,1))); title(['planck ' str])

  %%%%%%%%%%%%%%% opt depths
  loader = ['load Results/vt' num2str(ii) '_OPT.mat'];
  eval(loader);
  [m,n,p] = size(plk_airs);
  n = 100-n+1;
  opt_airs = opt_airs(:,n:100,:);

  loader = ['load Results/vt' num2str(ii) '_LTE.mat'];
  eval(loader);
  [m,n,p] = size(plk_airs);
  n = 100-n+1;
  lte_airs = lte_airs(:,n:100,:);

  figure(3)
  subplot(211)
  plot(fout,squeeze(opt_airs(:,:,1))); title(['opt depths ' str])
  subplot(212)
  plot(fout,squeeze(opt_airs(:,:,1)./lte_airs(:,:,1)))

  %%%%%%%%%%%%%%% l2s transmittances
  loader = ['load Results/vt' num2str(ii) '_L2S.mat'];
  eval(loader);
  [m,n,p] = size(l2s_airs);
  n = 100-n+1;
  l2s_airs = l2s_airs(:,n:100,:);

  loader = ['load Results/vt' num2str(ii) '_LTE_L2S.mat'];
  eval(loader);
  [m,n,p] = size(l2s_lte_airs);
  n = 100-n+1;
  l2s_lte_airs = l2s_lte_airs(:,n:100,:);

  %tranmittance of TOA = 1, so effective L2S of layer 100 is same as computed
  scott_l2s     = l2s_airs;
  scott_l2s_lte = l2s_lte_airs;
  for n = 99:-1:1
    scott_l2s(:,n,:)     = l2s_airs(:,n,:)./l2s_airs(:,n+1,:);
    scott_l2s_lte(:,n,:) = l2s_lte_airs(:,n,:)./l2s_lte_airs(:,n+1,:);
    end

  figure(4)
  subplot(211)
  plot(fout,squeeze(l2s_airs(:,:,1))); title(['l2s ' str])
  subplot(212)
  plot(fout,squeeze(l2s_airs(:,:,1)./l2s_lte_airs(:,:,1)))

  figure(5)
  subplot(211)
  plot(fout,squeeze(scott_l2s(:,:,1))); title(['effective l2s ' str])
  subplot(212)
  plot(fout,squeeze(scott_l2s(:,:,1)./scott_l2s_lte(:,:,1)))

  %%%%%%%%%%%%%%% NLTE temperature differences from LTE temperature
  loader = ['sergio_merge/vt' num2str(ii) '_s0.sss'];
  loader = ['data = load(''' loader ''');'];
  eval(loader);
  
  figure(6)
  subplot(211);
  semilogy(data(:,3),data(:,2),'b',data(:,4),data(:,2),'r'); grid;  hold on
  subplot(212); 
  semilogy(data(:,4)-data(:,3),data(:,2),data(:,8)-data(:,3),data(:,2),...
           data(:,10)-data(:,3),data(:,2)); hold on;
    grid

  co2_ss = data(:,4)-data(:,3);    ss(ii) = mean(co2_ss);
  co2_pp = data(:,8)-data(:,3);    pp(ii) = mean(co2_pp);
  co2_dd = data(:,10)-data(:,3);   dd(ii) = mean(co2_dd);

  %%%%%%%%%%%%%%% profile info
  figure(7)
  subplot(121)
  semilogy(ppp.ptemp(:,[ii 1]),ppp.plays(:,[ii 1]));
  subplot(122)
  loglog(ppp.gas_1(:,[ii 1]),ppp.plays(:,[ii 1]));
  water(ii) = sum(ppp.gas_1(:,[ii]));
  %%%%%%%%%%%%

  figure(2); figure(4);
  pause(1);
  
  end

figure(8);
subplot(311); plot(water,tdiffer,'.')
subplot(312); plot([ss;pp;dd],tdiffer,'.')
subplot(313); plot(tdiffer_solar,'.')
