function [nlte,lte] = driver_test_lte_nlte(iProf,solang,scanang,XCO2)

% this is in /home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/Translate_Manuel2Sergio_F77/driver_test_lte_nlte.m
%            /home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE2/sergio/VT_48PROFILES/driver_test_lte_nlte_umbcprofiles.m
% this version deals with Manuel's Jan 2025 profiles  .. assumes CO2 = 370,415,460 ppm
% driver_test_lte_nlte(1,30,0,370)

%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ mv lte_120km.nml lte_120km_TEST.nml
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ mv nlte_120km.nml nlte_120km_TEST.nml
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ mv usual_lte_120km.nml usual_lte_120km_TEST.nml
%% %
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ cp lte_120km_TEST.nml lte_120km_CLUSTER.nml
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ cp nlte_120km_TEST.nml nlte_120km_CLUSTER.nml
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ cp usual_lte_120km_TEST.nml usual_lte_120km_CLUSTER.nml
%% %
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ ln -s lte_120km_TEST.nml lte_120km.nml
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ ln -s nlte_120km_TEST.nml nlte_120km.nml
%% [sergio@taki-usr2 Translate_Manuel2Sergio_F77]$ ln -s usual_lte_120km_TEST.nml usual_lte_120km.nml

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

addpath /asl/matlib/h4tools
addpath /home/sergio/KCARTA/MATLAB
addpath /home/sergio/MATLABCODE 
addpath /home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/

if nargin == 3
  XCO2 = 415;
end

f1 = 2105;
f2 = 2505;

ZOF = iProf;

XYZCO2 = XCO2;
if XCO2 == 370
  iCO2 = 1;
elseif XCO2 == 415
  iCO2 = 2;
elseif XCO2 == 460
  iCO2 = 3;
end

[h,ha,p,pa] = rtpread(['../manuel_jan_2025_' num2str(XYZCO2) '_ppmv.rp.rtp']);
frtp = ['JUNK_PROCESS/junk_manuel_jan_2025_' num2str(XYZCO2) '_ppmv_' num2str(scanang) '.rp.rtp'];
p.solzen  = ones(size(p.scanang)) * solang;
p.zobs    = ones(size(p.scanang)) * 705000;
p.scanang = ones(size(p.scanang)) * scanang;
p.satzen = vaconv(p.scanang, p.zobs, zeros(size(p.zobs)));
rtpwrite(frtp,h,ha,p,pa)

sedder = ['!sed -e "s/FF1/' num2str(f1) '/g"  -e "s/FF2/' num2str(f2) '/g" '];               %% wn1,wn2
sedder = [sedder ' -e "s/ZOF/' num2str(iProf) '/g" '];                                       %% profile
sedder = [sedder ' -e "s/SSS/' num2str(scanang) '/g" '];                                     %% scanang
sedder = [sedder ' -e "s/SOL/' num2str(solang) '/g" '];                                      %% solzen
sedder = [sedder ' -e "s/XYZCO2/' num2str(XYZCO2) '/g"  -e "s/iCO2/' num2str(iCO2) '/g" '];  %% co2 ppmv

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
usuallte_nml = ['JUNK_PROCESS/usualltejunk_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.nml'];
usuallte_out = ['JUNK_PROCESS/usuallterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
sedderX = [sedder ' usual_lte_120km.nml > ' usuallte_nml];
fprintf(1,'LTE sedder = %s \n',sedderX)
eval(sedderX)

kcarta = '/home/sergio/KCARTA/BIN/kcarta.x_f77_118_400ppmv_H16_NLTEH16_120NLTElayers_new';
kcarta = '/home/sergio/KCARTA/BIN/kcarta.x_f90_122_400ppmv_H20';

kcartaer = ['!time ' kcarta ' ' usuallte_nml ' ' usuallte_out];
fprintf(1,'USUAL LTE kcartaer = %s \n',kcartaer)
eval(kcartaer)

lte_nml = ['JUNK_PROCESS/ltejunk_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.nml'];
lte_out = ['JUNK_PROCESS/lterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
sedderX = [sedder ' lte_120km.nml > ' lte_nml];
fprintf(1,'LTE sedder = %s \n',sedderX)
eval(sedderX)
kcartaer = ['!time ' kcarta ' ' lte_nml ' ' lte_out];
fprintf(1,'LTE kcartaer = %s \n',kcartaer)
eval(kcartaer)

nlte_nml = ['JUNK_PROCESS/nltejunk_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.nml'];
nlte_out = ['JUNK_PROCESS/nlterad_' num2str(iProf,'%03d') '_' num2str(solang,'%03d') '_' num2str(scanang,'%03d') '.dat'];
sedderX = [sedder ' nlte_120km.nml > ' nlte_nml];
fprintf(1,'NLTE sedder = %s \n',sedderX)
eval(sedderX)
kcartaer = ['!time ' kcarta ' ' nlte_nml ' ' nlte_out];
fprintf(1,'NLTE kcartaer = %s \n',kcartaer)
eval(kcartaer)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[dusual,w] = readkcstd(usuallte_out);
[dlte  ,w]  = readkcstd(lte_out);
[dnlte ,w]  = readkcstd(nlte_out);

[fc,qc] = quickconvolve(w,[dusual dlte dnlte],1,1);
tc = rad2bt(fc,qc);
figure(1); clf
  plot(fc,tc)
  plot(fc,tc(:,2)-tc(:,1),'b.-',fc,tc(:,3)-tc(:,1),'r')

theNLTEprof = ['../Set001_100/Sergio_vt_profs_1_100/sergio_merge/NLTE/vt' num2str(ZOF) '_s' num2str(solang) '_co2_' num2str(iCO2) '.prf'];
dirIN = '../Set001_100/Sergio_vt_profs_1_100/';
iSol = solang;
ii = ZOF;
  [dataVT,dataVMR,dataVTS] = read_manuel_pt_vmr_vts(dirIN,ii,iSol,iCO2);

%% see ../driver_compare_vts_new.m
press = -5:0.1:3;
press = 10.^press;
  dataVTS.P = interp1(dataVT.Z,dataVT.P,dataVTS.Z);
  tkinetic = interp1(log(dataVT.P),dataVT.T,log(press),[],'extrap');

  ix = find(dataVTS.hitranL == 21 & dataVTS.hitranU == 9);  %% 2349 cm-1
  tvib2350 = interp1(log(dataVTS.P),dataVTS.tvib(ix,:),log(press),[],'extrap');

figure(2); clf
  semilogy(tvib2350-tkinetic,press); set(gca,'ydir','reverse'); ylim([1e-5 1e3]); plotaxis2;
  title('2349 cm-1 strong band'); xlabel('Tvib-Tkinetic [K]'); ylabel('Press [mb]')

fprintf(1,'When happy, move files from JUNK_PROCESS to JUNK_PROCESS/%3i or JUNK_PROCESS/%3i \n',XCO2,XCO2+1)
fprintf(1,'and you can eg use compare_calcs_Jan2025_profiles_differentco2(iProf,solang,scanang,XCO2A,XCO2B)    when comparing eg 370,415 ppmv')
fprintf(1,'                   compare_calcs_Jan2025_profiles_differentco2(iProf,solang,scanang,XCO2A,XCO2A+1)  when comparing eg 370,371 ppmv')

 caaUpperMixRatio   = ['/asl/data/kcarta_sergio/KCDATA/NLTE/UA/std_gasID_2_400.ip'];
   thedefault_UA = load(caaUpperMixRatio);
 caaUpperMixRatio   = ['/asl/data/kcarta_sergio/KCDATA/NLTE/UA/manuel_jan2025_gasID_2_' num2str(XCO2) '.ip'];
   thenew_UA = load(caaUpperMixRatio);
figure(3); clf;
  plot(thedefault_UA(:,3),thedefault_UA(:,1),'b',thenew_UA(:,3),thenew_UA(:,1),'r'); ylabel('Z [km]'); xlabel('T [K]'); title('120 km profile (b) old 2006 (r) Manuel 2025')
figure(4); clf;
  plot(thedefault_UA(:,4)*XCO2/400,thedefault_UA(:,1),'b',thenew_UA(:,4),thenew_UA(:,1),'r'); ylabel('Z [km]'); xlabel('CO2 [ppm]'); title('120 km profile (b) old 2006 (r) Manuel 2025')
