addpath /home/sergio/MATLABCODE
addpath /home/sergio/MATLABCODE/COLORMAP
addpath /home/sergio/MATLABCODE/COLORMAP/LLS
addpath /home/sergio/git/CRODGERS_FAST_CLOUD/
addpath /asl/matlib/h4tools
addpath /home/sergio/git/rtp_prod2/util

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('reading in a random day, random rtp')
sarta = '/home/sergio/SARTA_CLOUDY_RTP_KLAYERS_NLEVELS/JACvers/bin/jac_airs_l1c_2834_cloudy_jan25_H2020';
klayers = '/asl/packages/klayersV205/BinV201/klayers_airs';

[hrandom,ha,prandom,pa] = rtpread('/asl/rtp/airs/airs_l1c_v672/random/2021/ecmwf_airicrad_day104_random.rtp');
ir2350 = find(hrandom.vchan >= 2350,1);
[hrandom2350,prandom2350] = subset_rtp_allcloudfields(hrandom,prandom,[],hrandom.ichan(ir2350),[]);
prandom2350.solzen = 150 * ones(size(prandom2350.solzen));
rtpwrite('junk.ip.rtp',hrandom2350,ha,prandom2350,pa);
klayerser = ['!' klayers ' fin=junk.ip.rtp fout=junk.op.rtp >& ugh'];
sartaer   = ['!' sarta   ' fin=junk.op.rtp fout=junk.rp.rtp >& ugh'];
eval(klayerser)
eval(sartaer)
[hrandom2350,ha,prandom2350,pa] = rtpread('junk.rp.rtp');

t2350    = rad2bt(2350,prandom.robs1(ir2350,:));
t2350cal = rad2bt(2350,prandom.rcld(ir2350,:));
t2350ngt = rad2bt(2350,prandom2350.rcalc);
scatter(prandom.solzen,prandom.rlat,10,t2350); colormap jet; colorbar; xlabel('solzen'); ylabel('Latitude'); title('Colorbar = BT 2350 obs');
latbin = -90:10:+90;
for ii = 1 : length(latbin)-1
  boo = find(prandom.rlat >= latbin(ii) & prandom.rlat < latbin(ii+1) & prandom.solzen < 90);
    cnt(ii,1) = length(boo);
    meanBT2350(ii,1)    = nanmean(t2350(boo));
    meanBT2350cal(ii,1) = nanmean(t2350cal(boo));    
    meanBT2350ngt(ii,1) = nanmean(t2350ngt(boo));
    meansolzen(ii,1) = nanmean(prandom.solzen(boo));
  boo = find(prandom.rlat >= latbin(ii) & prandom.rlat < latbin(ii+1) & prandom.solzen >= 90);
    cnt(ii,2) = length(boo);
    meanBT2350(ii,2) = nanmean(t2350(boo));
    meanBT2350cal(ii,2) = nanmean(t2350cal(boo));    
    meanBT2350ngt(ii,2) = nanmean(t2350ngt(boo));
    meansolzen(ii,2) = nanmean(prandom.solzen(boo));
end
plot(meanvaluebin(latbin),cnt); xlabel('Latbin'); ylabel('NumPts')
plot(meanvaluebin(latbin),meansolzen); xlabel('Latbin'); ylabel('Solzen')
plot(meanvaluebin(latbin),meanBT2350); xlabel('Latbin'); ylabel('BT 2350 Obs')

plot(meanvaluebin(latbin),meanBT2350(:,1)-meanBT2350(:,2),meanvaluebin(latbin),meanBT2350(:,1)-meanBT2350ngt(:,1)); xlabel('Latbin'); ylabel('BT 2350 (Day - Night)'); legend('DayObs - NgtObs','DayObs-SARTA night','fontsize',10,'location','best');

plot(meansolzen(:,1),meanBT2350(:,1)-meanBT2350(:,2),meansolzen(:,1),meanBT2350(:,1)-meanBT2350ngt(:,2)); xlabel('Solzen'); ylabel('BT 2350 (Day - Night)'); legend('DayObs - NgtObs','DayObs-SARTA night','fontsize',10,'location','best');

scatter(meansolzen(:,1),meanBT2350(:,1)-meanBT2350(:,2),100,meanvaluebin(latbin),'filled'); 
  xlabel('Solzen'); ylabel('BT 2350 Obs (Day - Night)'); title('Colorbar = Latitude'); colorbar
hold on; scatter(meansolzen(:,1),meanBT2350(:,1)-meanBT2350ngt(:,2),100,meanvaluebin(latbin),'filled','d'); 
  xlabel('Solzen'); ylabel('BT 2350 Obs (Day - Night)'); title('Colorbar = Latitude \newline (o) DayObs - NgtObs \newline (d) DayObs-SARTA night'); colorbar
hold off
disp('ret to continue'); pause

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

iCO2 = 415;
for iProf = 1 : 48
  fprintf(1,'doing iProf = %2i \n',iProf)
  [delta2021(iProf,:,:,:),delta2025(iProf,:,:,:),theangles] = compare_NLTE_LTE_Mar2025_vs_Apr2021(iProf,iCO2);
end

[h,ha,p,pa] = rtpread('../pin_feb2002_sea_airsnadir_ip.rtp');
hot = find(p.stemp >= 290);
cold = find(p.stemp < 273);
midlat = find(p.stemp >= 273 & p.stemp < 290);
whos hot cold midlat

%{
comment = 'see loop_compare_NLTE_LTE_Mar2025_vs_Apr2021.m';
saver = ['save deltaBT_2021vs2025_' num2str(iCO2) 'ppmv delta2021 delta2025 theangles iCO2 comment'];
eval(saver)
%}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[mm,nn,oo,pp] = size(delta2021);

unik = unique(theangles.sol(:));
for ii = 1 : length(unik)
  d2021 = squeeze(delta2021(:,:,ii,:));
  d2025 = squeeze(delta2025(:,:,ii,:));
  d2021 = permute(d2021,[2 1 3]);
  d2025 = permute(d2025,[2 1 3]);
  d2021 = reshape(d2021,nn,mm*pp);
  d2025 = reshape(d2025,nn,mm*pp);
  plot(theangles.freq,nanmean(d2021,2),'b',theangles.freq,nanmean(d2025,2),'r'); title(['solang = ' num2str(unik(ii))]);
  overall_solang_2021(:,ii) = nanmean(d2021,2);
  overall_solang_2025(:,ii) = nanmean(d2025,2);
  overall_solang_mean(:,ii) = nanmean(d2025-d2021,2);
  overall_solang_std(:,ii) = nanstd(d2025-d2021,[],2);
  pause(1)
end

i2350 = find(theangles.freq >= 2350,1);
i2320 = find(theangles.freq >= 2320,1);

[Y,I] = sort(theangles.freq);
plot(theangles.freq(I),overall_solang_2025(I,:)); title('mean(2025) vs solangle');      xlim([2200 2400]); plotaxis2; legend(num2str(unik),'fontsize',8,'location','best');
plot(theangles.freq(I),overall_solang_mean(I,:)); title('mean(2025-2021) vs solangle'); xlim([2200 2400]); plotaxis2; legend(num2str(unik),'fontsize',8,'location','best');
plot(theangles.freq(I),overall_solang_std(I,:));  title('std(2025-2021) vs solangle');  xlim([2200 2400]); plotaxis2; legend(num2str(unik),'fontsize',8,'location','best');

figure(5);
clf
plot(unik,overall_solang_2021(i2350,:),unik,overall_solang_2025(i2350,:),'linewidth',2); %%% 
hold on
  scatter(meansolzen(:,1),meanBT2350(:,1)-meanBT2350(:,2),100,meanvaluebin(latbin),'filled'); 
  scatter(meansolzen(:,1),meanBT2350(:,1)-meanBT2350ngt(:,2),100,meanvaluebin(latbin),'filled','d'); 
  xlabel('Solzen'); ylabel('BT 2350 Obs (Day - Night)'); title('Colorbar = Latitude \newline Dots are AIRS observations'); colorbar
hold off
xlabel('Solar Angle'); ylabel('BT NLTE-LTE');; plotaxis2; legend('2021','2025','fontsize',10);
title('Colorbar = Latitude \newline (o) DayObs - NgtObs \newline (d) DayObs-SARTA night');
caxis([-1 +1]*90)
colormap(jet)
colormap(usa2)
load('llsmap5'); colormap(llsmap5)

disp('ret to continue'); pause
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
iDoTVib = -1;  %% this is slooooooow but could be worth it
if iDoTVib > 0
  loop_compare_Tk_Tvib

  %{
  comment = 'see loop_compare_NLTE_LTE_Mar2025_vs_Apr2021.m and loop_compare_Tk_Tvib';
  saver = ['save deltaTvib_2021vs2025_' num2str(iCO2) 'ppmv common_all_grid unik iCO2 comment'];
  eval(saver)
  %}

end
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(4);

iUse = i2320;

delta_2350 = squeeze(delta2025(:,iUse,:,:,:)-delta2021(:,iUse,:,:,:));
pcolor(squeeze(nanmean(delta_2350,1)));  
  xlabel('Scanang'); ylabel('Solangle'); colormap jet; shading interp; colorbar; title('2025-2021 mean BT2350')
  caxis([-1 +1]*1)
  colormap(usa2)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
meandelta2021 = squeeze(nanmean(delta2021,1));
meandelta2025 = squeeze(nanmean(delta2025,1));
stddelta2025  = squeeze(nanstd(delta2025-delta2021,[],1));

iOffSet = 5;
figure(iOffSet+1); pcolor(theangles.sol,theangles.va,squeeze(meandelta2021(iUse,:,:))'); 
  xlabel('Scanang'); ylabel('Solangle'); colormap jet; shading interp; colorbar; title('2021 mean')
figure(iOffSet+2); pcolor(theangles.sol,theangles.va,squeeze(meandelta2025(iUse,:,:))'); 
  xlabel('Scanang'); ylabel('Solangle'); colormap jet; shading interp; colorbar; title('2025 mean');

figure(iOffSet+3); pcolor(theangles.sol,theangles.va,squeeze(meandelta2025(iUse,:,:))'-squeeze(meandelta2021(iUse,:,:))'); 
  xlabel('Scanang'); ylabel('Solangle'); colormap(usa2); shading interp; colorbar; title('2025-2021 mean diff')
  caxis([-1 +1]*1)

figure(iOffSet+4); pcolor(theangles.sol,theangles.va,squeeze(stddelta2025(iUse,:,:))'); 
  xlabel('Scanang'); ylabel('Solangle'); colormap(usa2); shading interp; colorbar; title('2025-2021 std diff')
  caxis([0 +1]*1)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
theblah = hot;
meandelta2021 = squeeze(nanmean(delta2021(theblah,:,:,:),1));
meandelta2025 = squeeze(nanmean(delta2025(theblah,:,:,:),1));
stddelta2025  = squeeze(nanstd(delta2025(theblah,:,:,:)-delta2021(theblah,:,:,:),[],1));

figure(iOffSet+1); pcolor(theangles.sol,theangles.va,squeeze(meandelta2021(iUse,:,:))'); 
  xlabel('Scanang'); ylabel('Solangle'); colormap jet; shading interp; colorbar; title('2021 mean')
figure(iOffSet+2); pcolor(theangles.sol,theangles.va,squeeze(meandelta2025(iUse,:,:))'); 
  xlabel('Scanang'); ylabel('Solangle'); colormap jet; shading interp; colorbar; title('2022 mean');

figure(iOffSet+3); pcolor(theangles.sol,theangles.va,squeeze(meandelta2025(iUse,:,:))'-squeeze(meandelta2021(iUse,:,:))'); 
  xlabel('Scanang'); ylabel('Solangle'); colormap(usa2); shading interp; colorbar; title('2025-2021 mean diff')
  caxis([-1 +1]*1)

figure(iOffSet+4); pcolor(theangles.sol,theangles.va,squeeze(stddelta2025(iUse,:,:))'); 
  xlabel('Scanang'); ylabel('Solangle'); colormap(usa2); shading interp; colorbar; title('2025-2021 std diff')
  caxis([0 +1]*1)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
