cd /home/sergio/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025
unik = unique(theangles.sol(:));
for iProf = 1 : 48
  for iss = 1 : length(unik)
    [~,~,~,~,common_grid] = driver_compare_vts_old_new(iProf,unik(iss));
    common_all_grid.Tvib0(iProf,iss,:,:) = common_grid.Tvib0;
    common_all_grid.TvibF(iProf,iss,:,:) = common_grid.TvibF;
    common_all_grid.Tk0(iProf,iss,:) = common_grid.Tk0;
    common_all_grid.TkF(iProf,iss,:) = common_grid.TkF;
  end
end
common_all_grid.Z = common_grid.Z;
common_all_grid.P = common_grid.P;

cd PRODUCTION_VT_48PROFILES_120_400ppmv_v122_H20_NLTEH16_Feb2025_NewConvolvers_Set001_100

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%% FIRST CHECK Tk %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(1); clf
figure(2); clf

disp('checking if Tk0 is the same across solar angles')
clear wah
for ii = 1 : 48
  wah(ii,:) = squeeze(nanstd(common_all_grid.Tk0(ii,:,:),[],2));
end
figure(1); pcolor(wah'); shading interp; xlabel('Profile'); ylabel('Z [km]'); colorbar; title('Tk0 stdev over different solar angles'); colormap jet
set(gca,'fontsize',12)

clear wah
for ii = 1 : 48
  wah(ii,:) = squeeze(nanstd(common_all_grid.TkF(ii,:,:),[],2));
end
figure(2); pcolor(wah'); shading interp; xlabel('Profile'); ylabel('Z [km]'); colorbar; titkle('TkF stdev over different solar angles'); colormap jet
set(gca,'fontsize',12)

%%%%%%%%%%%%%%%%%%%%%%%%%
disp('Checking mean Tk')
clear wah
for ii = 1 : 48
  wah(ii,:) = squeeze(nanmean(common_all_grid.Tk0(ii,:,:),2));
end
figure(1); pcolor(wah'); shading interp; xlabel('Profile'); ylabel('Z [km]'); colorbar; title('Tk0 mean over different solar angles'); colormap jet
set(gca,'fontsize',12)

clear wah
for ii = 1 : 48
  wah(ii,:) = squeeze(nanmean(common_all_grid.TkF(ii,:,:)-common_all_grid.Tk0(ii,:,:),2));
end
figure(2); pcolor(wah'); shading interp; xlabel('Profile'); ylabel('Z [km]'); colorbar; title('TkF -Tk0 mean over different solar angles'); colormap(usa2); caxis([-1 +1]*60);
set(gca,'fontsize',12)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%% NOW CHECK TVIB %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('Checking mean Tvib')
clear wah

iVib = 1;
iVib = 14;  %% strongest, see ../driver_compare_vts_old_new.m

for iVib = 1 : 57
  %for ii = 1 : 48
  %  wah(ii,:) = squeeze(nanmean(common_all_grid.Tvib0(ii,:,iVib,:),2));
  %end
  %figure(3); pcolor(wah'); shading interp; xlabel('Profile'); ylabel('Z [km]'); colorbar; title('Tvib0 mean over different solar angles'); colormap jet
  %set(gca,'fontsize',12)
  
  %% mean(TvibF)
  for ii = 1 : 48
    wah(ii,:) = squeeze(nanmean(common_all_grid.TvibF(ii,:,iVib,:),2));
  end
  figure(3); pcolor(wah'); shading interp; xlabel('Profile'); ylabel('Z [km]'); colorbar; title('TvibF mean over different solar angles'); colormap jet
  set(gca,'fontsize',12)
  
  %% mean(TvibF - Tvib0)
  for ii = 1 : 48
    wah(ii,:) = squeeze(nanmean(common_all_grid.TvibF(ii,:,iVib,:)-common_all_grid.Tvib0(ii,:,iVib,:),2));
  end
  figure(4); pcolor(wah'); shading interp; xlabel('Profile'); ylabel('Z [km]'); colorbar; title('TvibF -Tvib0 mean over different solar angles'); 
  colormap(usa2); caxis([-1 +1]*10);
  set(gca,'fontsize',12)

  %% mean(TvibF - TkF)
  for ii = 1 : 48
    bonk = squeeze(common_all_grid.TvibF(ii,:,iVib,:));
    wonk = squeeze(common_all_grid.TkF(ii,:,:));
    wah(ii,:) = squeeze(nanmean(bonk-wonk,1));
  end
  figure(5); pcolor(wah'); shading interp; xlabel('Profile'); ylabel('Z [km]'); colorbar; title('TvibF -TkF : mean over different solar angles'); 
  colormap(usa2); caxis([-1 +1]*60);
  set(gca,'fontsize',12)

  %% std(TvibF - TkF)
  for ii = 1 : 48
    bonk = squeeze(common_all_grid.TvibF(ii,:,iVib,:));
    wonk = squeeze(common_all_grid.TkF(ii,:,:));
    wah(ii,:) = squeeze(nanstd(bonk-wonk,[],1));
  end
  figure(6); pcolor(wah'); shading interp; xlabel('Profile'); ylabel('Z [km]'); colorbar; title('TvibF -TkF : std over different solar angles'); 
  colormap(jet); caxis([0 +1]*60);
  set(gca,'fontsize',12)

  pause
end


