function make_jan2025_co2_UA_prof_370_4015_460()

%% see kCARTA *nm_nlte, see caaUpperMixRatio = /asl/data/kcarta_sergio/KCDATA/NLTE/UA/std_gasID_2_400.ip
%% following info from 0-120 km
%%   z[km]       [mb]       T[K]    VMR[ppmv]     junk
% 9.000e+01   1.840e-03    186.900  3.758e+02  -1.234e+03
% 9.500e+01   7.600e-04    188.400  3.272e+02  -1.234e+03
% 1.000e+02   3.200e-04    195.100  2.363e+02  -1.234e+03
% 1.050e+02   1.450e-04    208.800  1.333e+02  -1.234e+03

dirIN0 = '../Set001_100/Sergio_vt_profs_1_100/';
iProf = 1;
aa = 0;
[dataVT1,dataVMR1,dataVTS1] = read_manuel_pt_vmr_vts(dirIN0,iProf,aa,1);   %% 370
[dataVT2,dataVMR2,dataVTS2] = read_manuel_pt_vmr_vts(dirIN0,iProf,aa,2);   %% 415
[dataVT3,dataVMR3,dataVTS3] = read_manuel_pt_vmr_vts(dirIN0,iProf,aa,3);   %% 460

plot(dataVT1.T,dataVT1.Z,'.-',dataVT2.T,dataVT2.Z,'p-',dataVT3.T,dataVT3.Z,'o-')
plot(dataVMR1.vmr(2,:),dataVMR1.Z,'.-',dataVMR2.vmr(2,:),dataVMR2.Z,'p-',dataVMR3.vmr(2,:),dataVMR3.Z,'o-')

%%%%%%%%%%%%%%%%%%%%%%%%%

%% subroutine MixRatio in ~/KCARTA/SRCv1.22_f90/kreadVTprofiles.f90 says there can be no more thn kProfLayer = 101 levels

Zuse = 0:1.5:120;

fid = fopen(['/asl/data/kcarta_sergio/KCDATA/NLTE/UA/manuel_jan2025_gasID_2_370.ip'],'w');
fprintf(fid,'%% see ~/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/PRODUCTION_VT_48PROFILES_120_400ppmv_v122_H20_NLTEH16_Feb2025_NewConvolvers_Set001_100/make_jan2025_co2_UA_prof_370_4015_460.m \n');
fprintf(fid,'%%   z[km]       [mb]       T[K]    VMR[ppmv]     junk \n');
junk = [dataVT1.Z  dataVT1.P  dataVT1.T  dataVMR1.vmr(2,:)' ones(size(dataVT1.Z))*-12345.0];
Zuse = 0:1.5:120;
junk = [Zuse; interp1(dataVT1.Z,dataVT1.P,Zuse,[],'extrap'); interp1(dataVT1.Z,dataVT1.T,Zuse,[],'extrap'); interp1(dataVT1.Z,dataVMR1.vmr(2,:),Zuse,[],'extrap'); ones(size(Zuse))*-12345.0]';
fprintf(fid,'%8.4e    %8.4e    %8.4f    %8.4e    %8.4e\n',junk');
fclose(fid);

fid = fopen(['/asl/data/kcarta_sergio/KCDATA/NLTE/UA/manuel_jan2025_gasID_2_415.ip'],'w');
fprintf(fid,'%% see ~/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/PRODUCTION_VT_48PROFILES_120_400ppmv_v122_H20_NLTEH16_Feb2025_NewConvolvers_Set001_100/make_jan2025_co2_UA_prof_370_4015_460.m \n');
fprintf(fid,'%%   z[km]       [mb]       T[K]    VMR[ppmv]     junk \n');
junk = [dataVT2.Z  dataVT2.P  dataVT2.T  dataVMR2.vmr(2,:)' ones(size(dataVT2.Z))*-12345.0];
Zuse = 0:1.5:120;
junk = [Zuse; interp1(dataVT2.Z,dataVT2.P,Zuse,[],'extrap'); interp1(dataVT2.Z,dataVT2.T,Zuse,[],'extrap'); interp1(dataVT2.Z,dataVMR2.vmr(2,:),Zuse,[],'extrap'); ones(size(Zuse))*-12345.0]';
fprintf(fid,'%8.4e    %8.4e    %8.4f    %8.4e    %8.4e\n',junk');
fclose(fid);

fid = fopen(['/asl/data/kcarta_sergio/KCDATA/NLTE/UA/manuel_jan2025_gasID_2_460.ip'],'w');
fprintf(fid,'%% see ~/IR_NIR_VIS_UV_RTcodes/NONLTEcode/NONLTE4_Jan2025/PRODUCTION_VT_48PROFILES_120_400ppmv_v122_H20_NLTEH16_Feb2025_NewConvolvers_Set001_100/make_jan2025_co2_UA_prof_370_4015_460.m \n');
fprintf(fid,'%%   z[km]       [mb]       T[K]    VMR[ppmv]     junk \n');
junk = [dataVT3.Z  dataVT3.P  dataVT3.T  dataVMR3.vmr(2,:)' ones(size(dataVT3.Z))*-12345.0];
Zuse = 0:1.5:120;
junk = [Zuse; interp1(dataVT3.Z,dataVT3.P,Zuse,[],'extrap'); interp1(dataVT3.Z,dataVT3.T,Zuse,[],'extrap'); interp1(dataVT3.Z,dataVMR3.vmr(2,:),Zuse,[],'extrap'); ones(size(Zuse))*-12345.0]';
fprintf(fid,'%8.4e    %8.4e    %8.4f    %8.4e    %8.4e\n',junk');
fclose(fid);
