function [w,solar,viewer] = opt_planck_results(iProf,iType);
%function [w,da_opt,da_planck,solar,viewer] = opt_planck_results(iProf,iType);

%%
iSol = [0 40 60 80 85];
va   = [51.07];
kk   = 0;

if iType == -1
  for vv = 1 : length(va)
    for ii = 1 : length(iSol)
      kk = kk + 1;
      solar(kk)  = iSol(ii);
      viewer(kk) = va(vv);
      dir = '/home/sergio/KCARTA/SRC/NONLTE2/sergio/VT_48PROFILES/Results/';

      fname1 = [dir 'vt' num2str(iProf) '_sun' num2str(iSol(ii)) '_lte.dat'];
      fprintf(1,'opt : %s \n',fname1);
      [da_lte(kk,:,:),w] = readkcstd(fname1);

      end 
    end
  end

if iType == 1
  for vv = 1 : length(va)
    for ii = 1 : length(iSol)
      kk = kk + 1;
      solar(kk)  = iSol(ii);
      viewer(kk) = va(vv);
      dir = '/home/sergio/KCARTA/SRC/NONLTE2/sergio/VT_48PROFILES/Results/';

      fname1 = [dir 'vt' num2str(iProf) '_sun' num2str(iSol(ii)) '.dat'];
      fprintf(1,'opt : %s \n',fname1);
      [da_opt(kk,:,:),w] = readkcstd(fname1);

      end 
    end
  end

if iType == -2
  for vv = 1 : length(va)
    for ii = 1 : length(iSol)
      kk = kk + 1;
      solar(kk)  = iSol(ii);
      viewer(kk) = va(vv);
      dir = '/home/sergio/KCARTA/SRC/NONLTE2/sergio/VT_48PROFILES/Results/';

      fname1 = [dir 'vt' num2str(iProf) '_sun' num2str(iSol(ii)) '_lte.dat'];
      fprintf(1,'l2s : %s \n',fname1);
      [d,w] = readkcstd(fname1);

      d = d(:,1:100);
      ttlr = fliplr(d);
      ttcs = cumsum(ttlr'); ttcs = ttcs'; ttcs = fliplr(ttcs); ttcs = exp(-ttcs);
      da_l2s_lte(kk,:,:) = ttcs;
      clear ttlr ttcs 
      end 
    end
  end

if iType == 2
  for vv = 1 : length(va)
    for ii = 1 : length(iSol)
      kk = kk + 1;
      solar(kk)  = iSol(ii);
      viewer(kk) = va(vv);
      dir = '/home/sergio/KCARTA/SRC/NONLTE2/sergio/VT_48PROFILES/Results/';

      fname1 = [dir 'vt' num2str(iProf) '_sun' num2str(iSol(ii)) '.dat'];
      fprintf(1,'l2s : %s \n',fname1);
      [d,w] = readkcstd(fname1);

      d = d(:,1:100);
      ttlr = fliplr(d);
      ttcs = cumsum(ttlr'); ttcs = ttcs'; ttcs = fliplr(ttcs); ttcs = exp(-ttcs);
      da_l2s(kk,:,:) = ttcs;
      clear ttlr ttcs 
      end 
    end
  end

if iType == 3
  kk   = 0;
  for vv = 1 : length(va)
    for ii = 1 : length(iSol)
      kk = kk + 1;
      solar(kk)  = iSol(ii);
      viewer(kk) = va(vv);
      dir = '/home/sergio/KCARTA/SRC/NONLTE2/sergio/VT_48PROFILES/Results/';

      fname2 = [dir 'vt' num2str(iProf) '_sun' num2str(iSol(ii)) '.dat_PLANCK'];
      fprintf(1,' planck : %s \n',fname2);
      [da_planck(kk,:,:),w] = readkcflux(fname2);
      end
    end
  end

%clist = 1 :2378; 
fin='/yam/s2/asl/ops/airs/tlscf/2002/10/19/airibrad/ecmwfn/uniform_clear107.rtp';
[h,ha,p,pa] = rtpread(fin);
f = h.vchan;
clist = find(f >= 2115 & f <= 2495);
addpath /asl/matlab/sconv
sfile = '/asl/matlab/srftest/srftables_m16_155K.hdf';
sfile = '/asl/data/airs/srf/srftables_020614v1.hdf';
sfile = '/asl/data/airs/srf/srftables_m135_fringes.hdf';
%[fc,qc_nlte] = quickconvolve(w,da_opt,2,0.5);
ii = 1 : length(w); w = w(1) + (ii-1)*0.0025; 

if iType == -1
  for ii = 1 : length(iSol)
    [lte_airs(:,:,ii), fout] = sconv2(squeeze(da_lte(ii,:,:)),    w, clist, sfile);
    end
  fname = [dir 'vt' num2str(iProf)  '_LTE.mat'];
  saver = ['save ' fname ' fout lte_airs iSol iProf'];
  eval(saver)
  end

if iType == 1
  for ii = 1 : length(iSol)
    [opt_airs(:,:,ii), fout] = sconv2(squeeze(da_opt(ii,:,:)),    w, clist, sfile);
    end
  fname = [dir 'vt' num2str(iProf)  '_OPT.mat'];
  saver = ['save ' fname ' fout opt_airs iSol iProf'];
  eval(saver)
  end

if iType == -2
  for ii = 1 : length(iSol)
    [l2s_lte_airs(:,:,ii), fout] = sconv2(squeeze(da_l2s_lte(ii,:,:)),    w, clist, sfile);
    end
  fname = [dir 'vt' num2str(iProf)  '_LTE_L2S.mat'];
  saver = ['save ' fname ' fout l2s_lte_airs iSol iProf'];
  eval(saver)
  end

if iType == 2
  for ii = 1 : length(iSol)
    [l2s_airs(:,:,ii), fout] = sconv2(squeeze(da_l2s(ii,:,:)),    w, clist, sfile);
    end
  fname = [dir 'vt' num2str(iProf)  '_L2S.mat'];
  saver = ['save ' fname ' fout l2s_airs iSol iProf'];
  eval(saver)
  end

if iType == 3
  for ii = 1 : length(iSol)
    [plk_airs(:,:,ii), fout] = sconv2(squeeze(da_planck(ii,:,:)), w, clist, sfile);
    end
  fname = [dir 'vt' num2str(iProf)  '_PLANCK.mat'];
  saver = ['save ' fname ' fout plk_airs iSol iProf'];
  eval(saver)
  end

