function [data0,dataVT,dataVMR,dataVTS,common_grid] = driver_compare_vts_old_new(iProf,iSol,iCO2)

addpath /umbc/xfs2/strow/asl/s1/sergio/home/MATLABCODE_Git
%keyboard_nowindow

%% for ii = 1 : 20; driver_compare_vts_old_new(ii); pause; end

if nargin == 0
  iProf = 1;
  iSol = 0;
  iCO2 = 1;
elseif nargin == 1
  iSol = 0;
  iCO2 = 1;
elseif nargin == 2
  iCO2 = 1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dirIN0 = '../NONLTE3_Feb2021/PUERTAS_DATA/AIRS_CO2_VTs_v3_ig2_Dusk_Mar2020/forKCARTA/merge/';
dirIN0 = '../NONLTE3_Feb2021/PUERTAS_DATA/AIRS_CO2_VTs_v3_ig2_Dusk_Mar2020/vt_airs_v3_2/';
data0  = read_manuel_orig(dirIN0,iSol,iProf);
data00 = read_manuel_pt([dirIN0 '/pt/'],iProf);
data0.Tk = data00;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dirIN = 'Set001_100/Sergio_vt_profs_1_100/';
[dataVT,dataVMR,dataVTS] = read_manuel_pt_vmr_vts(dirIN,iProf,iSol,iCO2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%[min(dataVT.Z) max(dataVT.Z) min(dataVTS.Z) max(dataVTS.Z)]
%[sum(data0.hitran-dataVTS.hitran) sum(data0.hitranL-dataVTS.hitranL) sum(data0.hitranU-dataVTS.hitranU)]

dataVTS.P = interp1(dataVT.Z,dataVT.P,dataVTS.Z);
data0.P = interp1(dataVT.Z,dataVT.P,data0.Z);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

common_grid.Z = 1:120;
for ii = 1 : 57
  common_grid.Tvib0(ii,:) = interp1(data0.Z,  data0.tvib(ii,:),  common_grid.Z,[],'extrap');
  common_grid.TvibF(ii,:) = interp1(dataVTS.Z,dataVTS.tvib(ii,:),common_grid.Z,[],'extrap');
end
common_grid.Tk0 = interp1(data0.Tk.Z,data0.Tk.T,common_grid.Z,[],'extrap');
common_grid.TkF = interp1(dataVT.Z,  dataVT.T,  common_grid.Z,[],'extrap');
common_grid.P   = interp1(data0.Z,   data0.P,   common_grid.Z,[],'extrap');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%for ix = 1 : 57
%  %ix = 1;
%  %ix = find(data0.hitranL == 00011);
%  semilogy(data0.tvib(ix,:),data0.P,'bx-',dataVTS.tvib(ix,:),dataVTS.P,'r.-'); set(gca,'ydir','reverse'); ylim([min(min(data0.P),min(dataVTS.P)) max(max(data0.P),max(dataVTS.P))])
%  title(['HITRAN vibL/vibU = ' num2str(data0.hitranL(ix)) '/' num2str(data0.hitranU(ix)) '  Band ' num2str(data0.hitran(ix)) '\newline BandCtr ' num2str(data0.vibcenter(ix)) ' cm-1'])
%  pause
%end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(1); clf
ix = find(data0.hitranL == 21 & data0.hitranU == 2);  %% 0667 cm-1
  plot(data0.tvib(ix,:),data0.Z,'bx-',dataVTS.tvib(ix,:),dataVTS.Z,'r.-',dataVT.T,dataVT.Z,'k'); set(gca,'ydir','reverse'); 
  ylim([0 150])
  str = ['HITRAN vibL/vibU = ' num2str(data0.hitranL(ix)) '/' num2str(data0.hitranU(ix)) '  Band ' num2str(data0.hitran(ix)) '\newline BandCtr ' num2str(data0.vibcenter(ix)) ' cm-1'];
  str = [str '   index = ' num2str(ix)];
  title(str)
  ylabel('X [km]');
xlim([180 320])
set(gca,'fontsize',12)
legend('2020 Tvib','2025 Tvib','2025 Tk','location','best','fontsize',10);

figure(2); clf
ix = find(data0.hitranL == 21 & data0.hitranU == 9);  %% 2349 cm-1
  plot(data0.tvib(ix,:),data0.Z,'bx-',dataVTS.tvib(ix,:),dataVTS.Z,'r.-',dataVT.T,dataVT.Z,'k'); set(gca,'ydir','reverse'); 
  ylim([0 150])
  str = ['HITRAN vibL/vibU = ' num2str(data0.hitranL(ix)) '/' num2str(data0.hitranU(ix)) '  Band ' num2str(data0.hitran(ix)) '\newline BandCtr ' num2str(data0.vibcenter(ix)) ' cm-1'];
  str = [str '   index = ' num2str(ix)];
  title(str)
  ylabel('Z [km]');
xlim([180 320])
set(gca,'fontsize',12)
legend('2020 Tvib','2025 Tvib','2025 Tk','location','best','fontsize',10);

figure(3); clf
  plot(data0.Tk.T,data0.Tk.Z,'k',dataVT.T,dataVT.Z,'r','linewidth',2); 
  ylim([0 150])
  title('Tk')
  ylabel('Z [km]');
xlim([180 320])
axis([150 350 0 160])
set(gca,'fontsize',12)
legend('2021 Tk','2025 Tk','location','best','fontsize',10);

%% https://htmlcolorcodes.com/colors/shades-of-green/
brwn = [200 100 16]/256;
vlet = [160 81 151]/256;
orng = [240 100 10]/256;
army = [0.29 0.33 0.13];;
leaf = [0 155 55 ]/256;
teal = [0 95 97]/256;
navy = [0 50 121]/256;
blue = [0 0 153]/256;
chst = [150 70 40]/256;
gren = [80 200 120]/256;
gren = [15 255 80]/256;

figure(4); clf
plot(data0.Tk.T,data0.Tk.Z,'k:',dataVT.T,dataVT.Z,'k','linewidth',2); hold on
ix1 = find(data0.hitran == 00011 & data0.hitranL == 21);
  plot(data0.tvib(ix1,:),data0.Z,'r:',dataVTS.tvib(ix1,:),dataVTS.Z,'r','linewidth',2)
ix2 = find(data0.hitran == 00011 & data0.hitranL == 22);
  plot(data0.tvib(ix2,:),data0.Z,'g:',dataVTS.tvib(ix2,:),dataVTS.Z,'g','linewidth',2)
ix3 = find(data0.hitran == 00011 & data0.hitranL == 23);
  plot(data0.tvib(ix3,:),data0.Z,'b:',dataVTS.tvib(ix3,:),dataVTS.Z,'b','linewidth',2)
ix4 = find(data0.hitran == 00011 & data0.hitranL == 24);
  plot(data0.tvib(ix4,:),data0.Z,'c:',dataVTS.tvib(ix4,:),dataVTS.Z,'c','linewidth',2)
ix5 = find(data0.hitran == 01111 & data0.hitranL == 21);
  plot(data0.tvib(ix5,:),data0.Z,'m:',dataVTS.tvib(ix5,:),dataVTS.Z,'m','linewidth',2)
ix6 = find(data0.hitran == 10012 & data0.hitranL == 21);
  plot(data0.tvib(ix6,:),data0.Z,'color',orng,'linestyle',':')
  plot(dataVTS.tvib(ix6,:),dataVTS.Z,'color',orng,'linewidth',2)
ix7 = find(data0.hitran == 11112 & data0.hitranL == 21);
  plot(data0.tvib(ix7,:),data0.Z,'color',leaf,'linestyle',':')
  plot(dataVTS.tvib(ix7,:),dataVTS.Z,'color',leaf,'linewidth',2)
ix8 = find(data0.hitran == 20013 & data0.hitranL == 21);
  plot(data0.tvib(ix8,:),data0.Z,'color',gren,'linestyle',':')
  plot(dataVTS.tvib(ix8,:),dataVTS.Z,'color',gren,'linewidth',2)
hold off
axis([150 350 0 120])
%hl = legend('Tk','21:00011','22:00011','23:00011','24:00011','21:01111','21:10012','21:11112','21:20013','location','best','fontsize',10);
set(gca,'fontsize',10);
title(['Profile ' num2str(iProf) ' Solar ' num2str(iSol)  ' CO2 ' num2str(iCO2)]);

figure(5); clf
plot(-interp1(data0.Tk.Z,data0.Tk.T,dataVT.Z,[],'extrap')+dataVT.T,dataVT.Z,'k:','linewidth',1); hold on
plot(-interp1(data0.Z,data0.tvib(ix1,:),dataVTS.Z,[],'extrap')+dataVTS.tvib(ix1,:)',dataVTS.Z,'r','linewidth',2)
plot(-interp1(data0.Z,data0.tvib(ix2,:),dataVTS.Z,[],'extrap')+dataVTS.tvib(ix2,:)',dataVTS.Z,'g','linewidth',2)
plot(-interp1(data0.Z,data0.tvib(ix3,:),dataVTS.Z,[],'extrap')+dataVTS.tvib(ix3,:)',dataVTS.Z,'b','linewidth',2)
plot(-interp1(data0.Z,data0.tvib(ix4,:),dataVTS.Z,[],'extrap')+dataVTS.tvib(ix4,:)',dataVTS.Z,'c','linewidth',2)
plot(-interp1(data0.Z,data0.tvib(ix5,:),dataVTS.Z,[],'extrap')+dataVTS.tvib(ix5,:)',dataVTS.Z,'m','linewidth',2)
plot(-interp1(data0.Z,data0.tvib(ix6,:),dataVTS.Z,[],'extrap')+dataVTS.tvib(ix6,:)',dataVTS.Z,'color',orng,'linewidth',2)
plot(-interp1(data0.Z,data0.tvib(ix7,:),dataVTS.Z,[],'extrap')+dataVTS.tvib(ix7,:)',dataVTS.Z,'color',leaf,'linewidth',2)
plot(-interp1(data0.Z,data0.tvib(ix8,:),dataVTS.Z,[],'extrap')+dataVTS.tvib(ix8,:)',dataVTS.Z,'color',gren,'linewidth',2)
hold off
axis([-10 +10 0 120])
plotaxis2;
hl = legend('Tk','21:00011','22:00011','23:00011','24:00011','21:01111','21:10012','21:11112','21:20013','location','best','fontsize',10);
set(gca,'fontsize',10);
title(['Profile ' num2str(iProf) ' Solar ' num2str(iSol)  ' CO2 ' num2str(iCO2)]);

return

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(1); clf
yyaxis left
ix = find(data0.hitranL == 21 & data0.hitranU == 2);  %% 0667 cm-1
  semilogy(data0.tvib(ix,:),data0.P,'bx-',dataVTS.tvib(ix,:),dataVTS.P,'r.-',dataVT.T,dataVT.P,'k'); set(gca,'ydir','reverse'); 
  ylim([min(min(data0.P),min(dataVTS.P)) max(max(data0.P),max(dataVTS.P))])
  str = ['HITRAN vibL/vibU = ' num2str(data0.hitranL(ix)) '/' num2str(data0.hitranU(ix)) '  Band ' num2str(data0.hitran(ix)) '\newline BandCtr ' num2str(data0.vibcenter(ix)) ' cm-1'];
  str = [str '   index = ' num2str(ix)];
  title(str)
  ylabel('P [mb]');
yyaxis right
  plot(dataVT.T,dataVT.Z,'g'); 
  ylabel('H [km]');
xlim([180 320])
set(gca,'fontsize',12)
legend('2020 Tvib','2025 Tvib','2025 Tk','location','best','fontsize',10);

figure(2); clf
yyaxis left
ix = find(data0.hitranL == 21 & data0.hitranU == 9);  %% 2349 cm-1
  semilogy(data0.tvib(ix,:),data0.P,'bx-',dataVTS.tvib(ix,:),dataVTS.P,'r.-',dataVT.T,dataVT.P,'k'); set(gca,'ydir','reverse'); 
  ylim([min(min(data0.P),min(dataVTS.P)) max(max(data0.P),max(dataVTS.P))])
  str = ['HITRAN vibL/vibU = ' num2str(data0.hitranL(ix)) '/' num2str(data0.hitranU(ix)) '  Band ' num2str(data0.hitran(ix)) '\newline BandCtr ' num2str(data0.vibcenter(ix)) ' cm-1'];
  str = [str '   index = ' num2str(ix)];
  title(str)
  ylabel('P [mb]');
yyaxis right
  plot(dataVT.T,dataVT.Z,'g'); 
  ylabel('H [km]');
xlim([180 320])
set(gca,'fontsize',12)
legend('2020 Tvib','2025 Tvib','2025 Tk','location','best','fontsize',10);
