function [pChris,pManuel,hx] = driver_computerads_ChrisH_vs_Manuel(iCO2)
%% same as driver_computerads_ChrisH_vs_Manuel.m EXCEPT we change to 370, 415 or 460 ppm as needed

addpath /home/sergio/MATLABCODE/CONVERT_GAS_UNITS

%iCO2 = input('CO2 : Enter 370,415 or 460 ppm (default 415) : ');
%if length(iCO2) == 0
%  iCO2 = 415;
%end
if nargin == 0
  iCO2 = 415;
end

addpath /asl/matlib/h4tools
addpath /home/sergio/MATLABCODE

x = read_netcdf_lls('MAKE_vtPROF_sSOL_prf_Oct2024/saf_sub300_reg49_plv147_400ppm.nc');
y = load('MAKE_vtPROF_sSOL_prf_Oct2024/saf_sub300_reg49_plv147_400ppm.mat');

[h,ha,p,pa] = rtpread('/asl/packages/klayersV205/Test_rtpV201/pin_feb2002_sea_airsnadir_ip.rtp');

klayers = '/asl/packages/klayersV205/BinV201/klayers_airs';
klayers = '/home/sergio/SARTA_CLOUDY_RTP_KLAYERS_NLEVELS/KLAYERS_RTPv201_150levs_80km/KLAYERS/BinV201/klayers_airs';
sarta   = '/home/sergio/SARTA_CLOUDY_RTP_KLAYERS_NLEVELS/JACvers/bin/jac_airs_l1c_2834_cloudy_jan25_H2020';

klayerser = ['!' klayers ' fin=junk.ip.rtp fout=junk.op.rtp >& ugh1'];
sartaer =   ['!' sarta   ' fin=junk.op.rtp fout=junk.rp.rtp >& ugh2'];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[hx,pjunk]  = replicate_rtp_headprof(h,p,49,349);

hx.ngas = 3;
hx.glist = [ 1  2  3]';
hx.gunit = [10 10 10]'; %% ppmv
hx.nchan = 2378;
hx.ichan = (1: 2378)';
hx.pfields = 3;

pjunk = rmfield(pjunk,'gas_5');
pjunk = rmfield(pjunk,'gas_6');
pjunk = rmfield(pjunk,'rcalc');
pjunk.rcalc = zeros(2378,349);
pjunk.stemp = y.pcat.stemp;
pjunk.salti = y.pcat.salti;
pjunk.spres = y.pcat.spres;
pjunk.plevs = y.pcat.plevs;
pjunk.palts = y.pcat.palts;
pjunk.zobs = y.pcat.zobs;
pjunk.plevs = y.pcat.plevs;
pjunk.nlevs = y.pcat.nlevs;
pjunk.ptemp = y.pcat.ptemp;
pjunk.gas_1 = y.pcat.gas_1;
pjunk.gas_2 = y.pcat.gas_2;
pjunk.gas_3 = y.pcat.gas_3;

co2_chris = pjunk.gas_2(140,:);
for ii = 1 : length(co2_chris)
  mult = iCO2/co2_chris(ii);
  pjunk.gas_2(:,ii) = pjunk.gas_2(:,ii) * mult;
end
co2_chris = pjunk.gas_2(140,:);

rtpwrite('junk.ip.rtp',hx,ha,pjunk,pa);
eval(klayerser);
eval(sartaer);
[hx,ha,pChris,pa] = rtpread('junk.rp.rtp');
tChris = rad2bt(hx.vchan,pChris.rcalc);

figure(1); clf;
nx = pChris.nlevs(1)-1;
semilogy(pjunk.ptemp(:,1),pjunk.plevs(:,1),pChris.ptemp(1:nx,1),pChris.plevs(1:nx,1)); set(gca,'ydir','reverse')
loglog(pjunk.gas_1(:,1),pjunk.plevs(:,1),pChris.gas_1(1:nx,1),pChris.plevs(1:nx,1)); set(gca,'ydir','reverse')
plot(hx.vchan,nanmean(tChris'),hx.vchan,250+nanstd(tChris')); title('Chris')

disp('done Chris rads')
disp(' ')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[hx,pjunk] = replicate_rtp_headprof(h,p,49,349);

hx.ngas = 3;
hx.glist = [ 1  2  3]';
hx.gunit = [10 10 10]'; %% ppmv
hx.nchan = 2378;
hx.ichan = (1: 2378)';
hx.pfields = 1;

pjunk = rmfield(pjunk,'plevs');
pjunk = rmfield(pjunk,'ptemp');

pjunk = rmfield(pjunk,'gas_1');
pjunk = rmfield(pjunk,'gas_2');
pjunk = rmfield(pjunk,'gas_3');

pjunk = rmfield(pjunk,'gas_5');
pjunk = rmfield(pjunk,'gas_6');
pjunk = rmfield(pjunk,'rcalc');
pjunk.rcalc = zeros(2378,349);
pjunk.stemp = y.pcat.stemp;
pjunk.salti = y.pcat.salti;
pjunk.spres = y.pcat.spres;

if iCO2 == 370
  iXCO2 = 1;
elseif iCO2 == 415
  iXCO2 = 2;
elseif iCO2 == 460
  iXCO2 = 3;
end

for iProf = 1 : 349
  dir0 = 'Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/';
  data0_pt  = read_manuel_pt([dir0],iProf);
  data0_vmr = read_manuel_vmr([dir0],iProf);
  %data0_vmr = read_manuel_vmr_001_359_solang_co2([dir0],iProf);  %% use incorrect CO2 (388 ppmv) instead of 1,2,3 = 370,415,460 ppmv
  dataX.vmr = data0_vmr;
  dataX.pt  = data0_pt;  

  dir0 = 'Set201_349/Sergio_vt_profs_201_349_the_end/';
  dataZ_vmr = read_manuel_vmr_001_359_solang_co2([dir0 '/pt_vmrs/'],iProf,0,iXCO2);  %% use solzen = 0, incorrect CO2 (388 ppmv) instead of 1,2,3 = 370,415,460 ppmv
  dataX.vmr2 = dataZ_vmr;

  theP = exp(linspace(log(0.001),log(pjunk.spres(iProf)),120));
  pjunk.plevs(:,iProf) = theP;
  pjunk.nlevs(iProf) = 120;

  junk = interp1(log(dataX.pt.P),dataX.pt.T,log(theP),[],'extrap');
  pjunk.ptemp(:,iProf) = junk;

  junk = interp1(log(dataX.pt.P),dataX.vmr2.vmr(1,:),log(theP),[],'extrap');
  pjunk.gas_1(:,iProf) = junk;

  junk = interp1(log(dataX.pt.P),dataX.vmr2.vmr(2,:),log(theP),[],'extrap');
  pjunk.gas_2(:,iProf) = junk;
  %%%%%%%%%% pjunk.gas_2(:,iProf) = pjunk.gas_2(:,iProf) * co2_chris(iProf)/388;   %% this file is all at 388 ppm; the profile1 also has files at 370,415,460 ppm

  junk = interp1(log(dataX.pt.P),dataX.vmr2.vmr(3,:),log(theP),[],'extrap');
  pjunk.gas_3(:,iProf) = junk;

  %if iProf == 2
  %  error('kjasff;ajf')
  %end
end

co2_manuel = pjunk.gas_2(120,:);

rtpwrite('junk.ip.rtp',hx,ha,pjunk,pa);
eval(klayerser);
eval(sartaer);
[hx,ha,pManuel,pa] = rtpread('junk.rp.rtp');
mver = ['!/bin/mv junk.rp.rtp manuel_jan_2025_' num2str(iCO2) '_ppmv.rp.rtp'];
eval(mver)
tManuel = rad2bt(hx.vchan,pManuel.rcalc);

figure(2); clf;
nx = pManuel.nlevs(1)-1;
semilogy(pjunk.ptemp(:,1),pjunk.plevs(:,1),pManuel.ptemp(1:nx,1),pManuel.plevs(1:nx,1)); set(gca,'ydir','reverse')
loglog(pjunk.gas_1(:,1),pjunk.plevs(:,1),pManuel.gas_1(1:nx,1),pManuel.plevs(1:nx,1)); set(gca,'ydir','reverse')
plot(hx.vchan,nanmean(tManuel'),hx.vchan,250+nanstd(tManuel')); title('Manuel')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(3); clf
plot(hx.vchan,nanmean(tChris'-tManuel'),hx.vchan,nanstd(tChris'-tManuel')); title('SARTA LTE to 80 km : Chris-Manuel')
xlabel('Wavenumber'); ylabel('\delta BT [K]');
legend('bias','std','location','best','fontsize',10);

figure(4); clf
plot(hx.vchan,nanmean(tChris'-tManuel'),hx.vchan,nanstd(tChris'-tManuel')); title('SARTA LTE to 80 km : Chris-Manuel')
xlim([2190 2500]); xlabel('Wavenumber'); ylabel('\delta BT [K]'); plotaxis2; 
legend('bias','std','location','best','fontsize',10);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(5); clf
plot(1:349,co2_chris,'b.-',1:349,co2_manuel,'r'); title('CO2 at lower levels (b) chris (r) manuel')

figure(6); clf;
semilogy(nanmean(pChris.ptemp'-pManuel.ptemp'),nanmean(pChris.plevs'),'b',nanstd(pChris.ptemp'-pManuel.ptemp'),nanmean(pChris.plevs'),'c'); 
  set(gca,'ydir','reverse'); ylim([0.01 1000]); title('\delta T UMBC-Manuel')
  plotaxis2;
xlim([-1 +1])

semilogy(nanmean(pManuel.gas_1'./pChris.gas_1'),nanmean(pManuel.plevs'),'b',nanstd(pManuel.gas_1'./pChris.gas_1') + 1,nanmean(pManuel.plevs'),'c'); 
  set(gca,'ydir','reverse'); ylim([0.01 1000]); title('WV Manuel/UMBC')
  plotaxis2(1);
xlim([0 +2])

semilogy(nanmean(pManuel.gas_2'./pChris.gas_2'),nanmean(pManuel.plevs'),'b',nanstd(pManuel.gas_2'./pChris.gas_2') + 1,nanmean(pManuel.plevs'),'c'); 
  set(gca,'ydir','reverse'); ylim([0.01 1000]); title('CO2 Manuel/UMBC')
  plotaxis2(1);
xlim([0 +2])

semilogy(nanmean(pManuel.gas_3'./pChris.gas_3'),nanmean(pManuel.plevs'),'b',nanstd(pManuel.gas_3'./pChris.gas_3') + 1,nanmean(pManuel.plevs'),'c'); 
  set(gca,'ydir','reverse'); ylim([0.01 1000]); title('O3 Manuel/UMBC')
  plotaxis2(1);
xlim([0 +2])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(7); clf
scatter(mmwater_rtp(hx,pChris),mmwater_rtp(hx,pManuel),10,pChris.stemp,'filled'); title('mmw : colorbar = SKT'); xlabel('Chris'); ylabel('Manuel');
hold on; plot(mmwater_rtp(hx,pChris),mmwater_rtp(hx,pChris)); hold off
colorbar; colormap jet

figure(7); clf
scatter(co2_chris,co2_manuel,10,pChris.stemp,'filled'); title('CO2 ppmv : colorbar = SKT'); xlabel('Chris'); ylabel('Manuel');
hold on; plot(co2_chris,co2_chris); hold off
colorbar; colormap jet

figure(7); clf
scatter(dobson_rtp(hx,pChris),dobson_rtp(hx,pManuel),10,pChris.stemp,'filled'); title('O3 du : colorbar = SKT'); xlabel('Chris'); ylabel('Manuel');
hold on; plot(dobson_rtp(hx,pChris),dobson_rtp(hx,pChris)); hold off
colorbar; colormap jet

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(8); clf
co2_chris_ppmv  = layers2ppmv(hx,pChris,1:349,2);
co2_manuel_ppmv = layers2ppmv(hx,pManuel,1:349,2);

plot(co2_chris_ppmv(80,:),co2_manuel_ppmv(80,:),'b.',co2_chris_ppmv(90,:),co2_manuel_ppmv(90,:),'r.')
title('(b) 500 mb (r) 800 mb \newline CO2 from layers2ppmv'); xlabel('Chris'); ylabel('Manuel');

