addpath /asl/matlib/h4tools
addpath /home/sergio/MATLABCODE

y = load('MAKE_vtPROF_sSOL_prf_Oct2024/saf_sub300_reg49_plv147_400ppm.mat');
pumbc.gas_2 = y.pcat.gas_2;
pumbc.gas_1 = y.pcat.gas_1;
pumbc.gas_3 = y.pcat.gas_3;
pumbc.ptemp = y.pcat.ptemp;
pumbc.plevs = y.pcat.plevs;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% [sergio@taki-usr2 NONLTE4_Jan2025]$ ls -lt Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0*
% -rw-r----- 1 sergio pi_strow 26009 Jan 29 11:28 Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0_co2_1.prf
% -rw-r----- 1 sergio pi_strow 26009 Jan 29 11:25 Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0_co2_3.prf
%- rw-r----- 1 sergio pi_strow 26009 Jan 29 11:25 Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0_co2_2.prf
% -rw-r----- 1 sergio pi_strow 27292 Jan 20 09:22 Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0.prf

for iProf = 1 : 1
  dir0 = 'Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/';
  data0_pt  = read_manuel_pt([dir0],iProf);
  dataX.pt  = data0_pt;  

  data0_vmr = read_manuel_vmr([dir0],iProf);
  dataX.vmr1A = data0_vmr;

  data0_vmr = read_manuel_vmr_001_359_solang_co2([dir0],iProf); %% use incorrect CO2 (388 ppmv) instead of 1,2,3 = 370,415,460 ppmv
  dataX.vmr1B = data0_vmr;

  %%%%%%%%%%%%%%%%%%%%%%%%%
  dir0 = 'Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/';
  data0_vmr = read_manuel_vmr_001_359_solang_co2([dir0],iProf,0,0);  %% use solzen = 0,iCO2 = wrong (388 ppm)
  dataX.vmr2_0 = data0_vmr;

  dir0 = 'Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/';
  data0_vmr = read_manuel_vmr_001_359_solang_co2([dir0],iProf,0,1);  %% use solzen = 0,iCO2 = 1 370 ppm
  dataX.vmr2_1 = data0_vmr;

  dir0 = 'Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/';
  data0_vmr = read_manuel_vmr_001_359_solang_co2([dir0],iProf,0,2);  %% use solzen = 0,iCO2 = 1 415 ppm
  dataX.vmr2_2 = data0_vmr;

  dir0 = 'Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/';
  data0_vmr = read_manuel_vmr_001_359_solang_co2([dir0],iProf,0,3);  %% use solzen = 0,iCO2 = 1 460 ppm
  dataX.vmr2_3 = data0_vmr;

end

plot(dataX.vmr1A.vmr(2,:),dataX.pt.Z,'bo-',dataX.vmr2_0.vmr(2,:),dataX.pt.Z,'rx-','linewidth',2); hold on;
plot(dataX.vmr2_1.vmr(2,:),dataX.pt.Z,dataX.vmr2_2.vmr(2,:),dataX.pt.Z,dataX.vmr2_3.vmr(2,:),dataX.pt.Z)
legend('vmr1A','vmr2-0 388','vmr2-1 370','vmr2-0 415','vmr2-0 460','location','best','fontsize',10);
hold off

%{
comment = 'use dataX.pt dataX.vmr1A dataX.vmr2_1 dataX.vmr2_2 dataX.vmr2_3 : these are p,T and read_manuel_vmr (388 ppmv), then read_manuel_vmr_001_359_solang_co2 for 370,415,460 ppmv';
save important_save_co2_ppmv_370_415_460.mat dataX comment
%}
