function data = read_manuel_co2_vts(dirIN,aa,ii,co2);

%% read VTS = Tvib temps
%% ii = profile (1..49,40..349)   
%% aa = solzen = 0:10:120
%% co2 = 1:3 (370,415,460) -- see emailC.txt
%%
%% example : more  PUERTAS_DATA/AIRS_CO2_VTs_v3_ig2_Dusk_Mar2020/forKCARTA/merge/vt31_s40_co2.prf
%% ls Set001_100/Sergio_vt_profs_1_100/vts/vt1_s0_co2_1.prf
%%   Set001_100/Sergio_vt_profs_1_100/vts/vt1_s0_co2_1.prf
%% dirIN = 'Set001_100/Sergio_vt_profs_1_100/vts/';
%% data = read_manuel_co2(dirIN,0,1,1);

data = [];

fname = [dirIN '/vt' num2str(ii) '_s' num2str(aa) '_co2_' num2str(co2) '.prf'];
fprintf(1,'fname = %s \n',fname);

fid = fopen(fname,'r');
tline = fgetl(fid);      %% $
tline = fgetl(fid);      %% number of entries
data.numZ = str2num(tline);
fprintf(1,'  data.numZ = %3i \n',data.numZ)
tline = fgetl(fid);      %% [ ]

tline = fgetl(fid);      %% $
numlines = floor(data.numZ/5); 
tline1 = fscanf(fid,'%f',[numlines,5]);
tline2 = fscanf(fid,'%f',[1,data.numZ-(5*numlines)]);
data.Z = [tline1(:); tline2(:)];
tline = fgetl(fid);      %% [ ]

tline = fgetl(fid);      %% [ ]
tline = fgetl(fid);      %% $
tline = fgetl(fid);      %% F
tline = fgetl(fid);      %% [ ]

tline = fgetl(fid);      %% $
tline = fgetl(fid);      %% numV
data.numV  = str2num(tline);   %% number of vibrational modes data
fprintf(1,'  data.numVTS = %3i \n',data.numV)
tline = fgetl(fid);      %% [ ]

fprintf(1,'need to read in %2i Tvib bands \n',data.numV)
for nn = 1 : data.numV
  %fprintf(1,'  reading in band %2i of %2i \n',nn,data.numV)

  tline = fgetl(fid);      %% $ 10002   1285.4087
    tline = tline(2:end);
  data.hitran(nn)    = str2num(tline(01:10));    %% HITRAN band ID
  data.vibcenter(nn) = str2num(tline(11:end));   %% HITRAN band center
  tline = fgetl(fid);      %% 
    data.hitranL(nn) = str2num(tline);
  tline = fgetl(fid);      %% 
    data.hitranU(nn) = str2num(tline);
  tline1 = fscanf(fid,'%f',[numlines,5]);
  tline2 = fscanf(fid,'%f',[1,data.numZ-(5*numlines)]);
  tline = fgetl(fid);      %% eol
  data.tvib(nn,:) = [tline1(:); tline2(:)];
  tline = fgetl(fid);      %% [ ]

end

fclose(fid);



