function data = read_manuel_pt(dirIN,ii);

%% read PT = P/T
%% ii = profile (1..49,40..349)   
%% example : more  PUERTAS_DATA/AIRS_CO2_VTs_v3_ig2_Dusk_Mar2020/forKCARTA/merge/vt31_s40.prf
%% ls Set001_100/Sergio_vt_profs_1_100/pt/pt12.prf
%%   Set001_100/Sergio_vt_profs_1_100/pt/pt12.prf
%% dirIN = 'Set001_100/Sergio_vt_profs_1_100/pt/';
%% data = read_manuel_pt(dirIN,1);

data = [];

fname = [dirIN '/pt' num2str(ii) '.prf'];
fprintf(1,'fname = %s \n',fname);

fid = fopen(fname,'r');
tline = fgetl(fid);      %% mixer generated profiles
tline = fgetl(fid);      %% number of levels
tline = fgetl(fid);      %% $
tline = fgetl(fid);      %% number
data.numZ = str2num(tline);
fprintf(1,'  data.numZ = %3i \n',data.numZ)
tline = fgetl(fid);      %% [ ]

tline = fgetl(fid);      %% altitude [km]
tline = fgetl(fid);      %% $
numlines = floor(data.numZ/5);
tline1 = fscanf(fid,'%f',[numlines,5]);
tline2 = fscanf(fid,'%f',[1,data.numZ-(5*numlines)]);
data.Z = [tline1(:); tline2(:)];
  tline = fgetl(fid);    %% eol
tline = fgetl(fid);      %% [ ]

tline = fgetl(fid);      %% pressure [hPa]
tline = fgetl(fid);      %% $ ../atm/profile12.prf
numlines = floor(data.numZ/8);
tline1 = fscanf(fid,'%e',[numlines,8]);
tline2 = fscanf(fid,'%e',[1,data.numZ-(8*numlines)]);
data.P = [tline1(:); tline2(:)];
  tline = fgetl(fid);    %% eol
tline = fgetl(fid);      %% [ ]

tline = fgetl(fid);      %% temperature [K]
tline = fgetl(fid);      %% $ ../atm/profile12.prf
numlines = floor(data.numZ/8); 
tline1 = fscanf(fid,'%e',[numlines,8]);
tline2 = fscanf(fid,'%e',[1,data.numZ-(8*numlines)]);
data.T = [tline1(:); tline2(:)];
  tline = fgetl(fid);    %% eol
tline = fgetl(fid);      %% [ ]

fclose(fid);



