function data = read_manuel_vmr_001_200(dirIN,iProf,iCO2);

%% read VMR
%% iProf = profile (1..49,40..349)   
%% example : more  PUERTAS_DATA/AIRS_CO2_VTs_v3_ig2_Dusk_Mar2020/forKCARTA/merge/vt31_s40.prf
%% ls Set001_100/Sergio_vt_profs_1_100/vmr/vmr32_s0_co2_1.prf
%%   Set001_100/Sergio_vt_profs_1_100/vmr/vmr32_s0_co2_1.prf
%% dirIN = 'Set001_100/Sergio_vt_profs_1_100/vmr/';
%% data = read_manuel_vmr(dirIN,1);

data = [];

if nargin == 2
  iCO2 = 1;
end

if iProf > 1
  iCO2 = 1;
end

% if findstr(dirIN,'Set201_349')
%   error('this subroutine only works for vmr in Set001_100 and Set101_200')
% else
%   if iProf < 201
%     fname = [dirIN '/vmr' num2str(iProf) '_s0_co2_1.prf'];
%   else
%     error('only for profs 1-200')
%     fname = [dirIN '/vmr' num2str(iProf) '_s0.prf'];
%   end
% end

fname = [dirIN '/vmr' num2str(iProf) '_s0_co2_' num2str(iCO2) '.prf'];

fprintf(1,'fname = %s \n',fname);

fid = fopen(fname,'r');
tline = fgetl(fid);      %% VMRs profiles for atmosphere: mix_out/vmr62_s0.prf
tline = fgetl(fid);      %% CO2 profile 1      370.000 ppmv
tline = fgetl(fid);      %% Granada. Jan 2025
tline = fgetl(fid);      %% number of levels
tline = fgetl(fid);      %% $
tline = fgetl(fid);      %% number
data.numZ = str2num(tline);
fprintf(1,'  data.numZ = %3i \n',data.numZ)

tline = fgetl(fid);      %% Level altitude [km]
tline = fgetl(fid);      %% $
numlines = floor(data.numZ/5);
tline1 = fscanf(fid,'%f',[numlines,5]);
tline2 = fscanf(fid,'%f',[1,data.numZ-(5*numlines)]);
data.Z = [tline1(:); tline2(:)];
  tline = fgetl(fid);    %% eol
tline = fgetl(fid);      %% [ ]

tline = fgetl(fid);      %% Total number of following profiles
tline = fgetl(fid);      %% $
tline = fgetl(fid);      %% nG
data.nG = str2num(tline);
fprintf(1,'  data.nG = %3i \n',data.nG)

for gg = 1 : data.nG
  %tline = fgetl(fid);      %% name
  %junk = '     ';
  %junk(1:length(tline)-2) = tline(3:length(tline));
  %data.name(gg,:) = junk(1:end);
  %tline = fgetl(fid);      %% $ HITRANgid gname

  tline = fgetl(fid);      %% $ CO
  tline = fgetl(fid);      %% HITRANgid gname
  %if tline(7:8) == ' '
  %  tlineID   = tline(7:8);
  %  tlineNAME = tline(12:end);
  %else
  %  tlineID   = tline(7:8);
  %  tlineNAME = tline(12:end);
  %end
  tlineID   = tline(7:8);
  tlineNAME = tline(12:end);
  junk = '    ';
  junk(1:length(tlineNAME)) = tlineNAME;
  data.name(gg,:) = junk;
  data.gid(gg)    = str2num(tlineID);

  numlines = floor(data.numZ/8);
  tline1 = fscanf(fid,'%e',[numlines,8]);
  tline2 = fscanf(fid,'%e',[1,data.numZ-(8*numlines)]);
  data.vmr(gg,:) = [tline1(:); tline2(:)];
    tline = fgetl(fid);    %% eol
end

fclose(fid);



