function data = read_manuel_vmr_001_359_solang(dirIN,iProf,iSol);

%% read VMR
%% iProf = profile (1..49,40..349)   
%% example : more  PUERTAS_DATA/AIRS_CO2_VTs_v3_ig2_Dusk_Mar2020/forKCARTA/merge/vt31_s40.prf
%% ls Set001_100/Sergio_vt_profs_1_100/vmr/vmr32_s0_co2_1.prf
%%   Set001_100/Sergio_vt_profs_1_100/vmr/vmr32_s0_co2_1.prf
%% dirIN = 'Set001_100/Sergio_vt_profs_1_100/vmr/';
%% data = read_manuel_vmr(dirIN,1);

data = [];

% [sergio@taki-usr2 NONLTE4_Jan2025]$ ls -lt Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0*
% -rw-r----- 1 sergio pi_strow 26009 Jan 29 11:28 Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0_co2_1.prf
% -rw-r----- 1 sergio pi_strow 26009 Jan 29 11:25 Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0_co2_3.prf
%- rw-r----- 1 sergio pi_strow 26009 Jan 29 11:25 Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0_co2_2.prf
% -rw-r----- 1 sergio pi_strow 27292 Jan 20 09:22 Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0.prf
if nargin == 2
  iSol = 0;
end

fname = [dirIN '/vmr' num2str(iProf) '_s' num2str(iSol) '.prf'];
fprintf(1,'fname = %s \n',fname);

fid = fopen(fname,'r');
tline = fgetl(fid);      %% Mixer generated VMR  profile collection
tline = fgetl(fid);      %% number of levels
tline = fgetl(fid);      %% $
tline = fgetl(fid);      %% number
data.numZ = str2num(tline);
fprintf(1,'  data.numZ = %3i \n',data.numZ)
tline = fgetl(fid);      %% [ ]

tline = fgetl(fid);      %% Level altitude [km]
tline = fgetl(fid);      %% $
numlines = floor(data.numZ/5);
tline1 = fscanf(fid,'%f',[numlines,5]);
tline2 = fscanf(fid,'%f',[1,data.numZ-(5*numlines)]);
data.Z = [tline1(:); tline2(:)];
  tline = fgetl(fid);    %% eol
tline = fgetl(fid);      %% [ ]

tline = fgetl(fid);      %% number of gas profiles given below (at least for the
tline = fgetl(fid);      %% gases which have to be considered in all microwindows)
tline = fgetl(fid);      %% $
tline = fgetl(fid);      %% nG
data.nG = str2num(tline);
fprintf(1,'  data.nG = %3i \n',data.nG)
tline = fgetl(fid);      %% [ ]

tline = fgetl(fid);      %% hitran gas number
tline = fgetl(fid);      %% profile [ppmv]

for gg = 1 : data.nG
  tline = fgetl(fid);      %% $    /home/puertas/granada/prod_201508/ref_atm/IG_april-75.DAT
  tline = fgetl(fid);      %% HITRANgid gname
  if tline(2:3) == ' '
    tlineID   = tline(1:2);
    tlineNAME = tline(4:end);
  else
    tlineID   = tline(1:3);
    tlineNAME = tline(5:end);
  end
  junk = '    ';
  junk(1:length(tlineNAME)) = tlineNAME;
  data.name(gg,:) = junk;
  data.gid(gg)    = str2num(tlineID);
   
  numlines = floor(data.numZ/8);
  tline1 = fscanf(fid,'%e',[numlines,8]);
  tline2 = fscanf(fid,'%e',[1,data.numZ-(8*numlines)]);
  data.vmr(gg,:) = [tline1(:); tline2(:)];
    tline = fgetl(fid);    %% eol
end

fclose(fid);
