function data = read_manuel_vmr_001_359_solang_co2(dirIN,iProf,iSol,iCO2);

%% read VMR
%% iProf = profile (1..49,40..349)   
%% example : more  PUERTAS_DATA/AIRS_CO2_VTs_v3_ig2_Dusk_Mar2020/forKCARTA/merge/vt31_s40.prf
%% ls Set001_100/Sergio_vt_profs_1_100/vmr/vmr32_s0_co2_1.prf
%%   Set001_100/Sergio_vt_profs_1_100/vmr/vmr32_s0_co2_1.prf
%% dirIN = 'Set001_100/Sergio_vt_profs_1_100/vmr/';
%% data = read_manuel_vmr(dirIN,1);

data = [];

% [sergio@taki-usr2 NONLTE4_Jan2025]$ ls -lt Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0*
% -rw-r----- 1 sergio pi_strow 26009 Jan 29 11:28 Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0_co2_1.prf
% -rw-r----- 1 sergio pi_strow 26009 Jan 29 11:25 Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0_co2_3.prf
%- rw-r----- 1 sergio pi_strow 26009 Jan 29 11:25 Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0_co2_2.prf
% -rw-r----- 1 sergio pi_strow 27292 Jan 20 09:22 Set201_349/Sergio_vt_profs_201_349_the_end/pt_vmrs/vmr1_s0.prf
if nargin == 2
  iSol = 0;
  iCO2 = 0;   %% if you are reading profile 1, you have choice of 0 = wrong (388 ppmv) or 1,2,3 = 370,415,460 ppm
              %% for other profiles 2-349, they all have 388 pmmv so you also need to read in profile1(with iCO2 = 1,2,3) and then replace
              %% results from use important_save_co2_ppmv_370_415_460.m
elseif nargin == 3
  iCO2 = 0;   %% if you are reading profile 1, you have choice of 0 = wrong (388 ppmv) or 1,2,3 = 370,415,460 ppm
              %% for other profiles 2-349, they all have 388 pmmv so you also need to read in profile1(with iCO2 = 1,2,3) and then replace
              %% results from use important_save_co2_ppmv_370_415_460.m
end

if iCO2 == 0
  data = read_manuel_vmr_001_359_solang(dirIN,iProf,iSol);  
  return
end

if iProf == 1 & iCO2 > 0
  disp('read_manuel_vmr_001_359_solang_co2.m : using read_manuel_vmr_001_200, looks for fname = [dirIN ''/vmr'' num2str(iProf) ''_s0_co2_'' num2str(iCO2) ''.prf''];')
  data = read_manuel_vmr_001_200(dirIN,iProf,iCO2);

elseif iProf > 1 & iCO2 > 0

  %% why is this not working????? oh well
  %disp('read_manuel_vmr_001_359_solang_co2.m : using read_manuel_vmr_001_359_solang, looks for [dirIN ''/vmr'' num2str(iProf) ''_s'' num2str(iSol) ''.prf''];')
  %data = read_manuel_vmr_001_359_solang(dirIN,iProf,iSol);    

  disp('read_manuel_vmr_001_359_solang_co2.m : using read_manuel_vmr_001_200, looks for fname = [dirIN ''/vmr'' num2str(iProf) ''_s0_co2_'' num2str(iCO2) ''.prf''];')
  data = read_manuel_vmr_001_200(dirIN,iProf,iCO2);

  if exist('important_save_co2_ppmv_370_415_460.mat')
    load important_save_co2_ppmv_370_415_460.mat   %% this saves 370,415,460,388 ppmv
    if iCO2 == 1
      data.vmr(2,:) = dataX.vmr2_1.vmr(2,:);
    elseif iCO2 == 2
      data.vmr(2,:) = dataX.vmr2_2.vmr(2,:);
    elseif iCO2 == 3
      data.vmr(2,:) = dataX.vmr2_3.vmr(2,:);
    else
      error('need iCO2 = (0),1,2,3')
    end
  else
    disp('cannot read in important_save_co2_ppmv_370_415_460.mat so sticking with CO2 ppmv = 388 at ground')
  end
end
